﻿using System;
using System.Windows.Forms;

namespace AB3.TestWinFormGui
{
	static class Program
	{
		/// <summary>The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main()
		{
			Application.EnableVisualStyles();
			Application.SetCompatibleTextRenderingDefault(false);

			AppBuilder tAppBuilder = new AppBuilder();
			GuiPart tGui = new GuiPart();

			// Version 0 (Only MainFlow)
			//tAppBuilder.LoadFlowsFromString(AB3.TestWinFormGui.Properties.Resources.AlarmClockV0);
			//tAppBuilder.AddPreparedStepInstance("MainFlow", "GuiPart", tGui);

			// Version 1 (MainFlow & GuiFlow)
			//tAppBuilder.LoadFlowsFromString(AB3.TestWinFormGui.Properties.Resources.AlarmClockV1);
			//tAppBuilder.AddPreparedStepInstance("MainFlow.GuiFlow", "GuiPart", tGui);

			// Version 2 (MainFlow, GuiFlow, LogicFlow)
			tAppBuilder.LoadFlowsFromString(AB3.TestWinFormGui.Properties.Resources.AlarmClockV2);
			tAppBuilder.AddPreparedStepInstance("MainFlow.GuiFlow", tGui);

			tAppBuilder.BuildApp(null, null);
			Application.Run(tGui);
		} 
	}
}
