﻿
namespace AB3.DataTypes
{
	/// <summary>Represents an endpoint of an connection defined in FDL
	/// </summary>
	public class ConnectionEndPoint
	{
		/// <summary>Namespace of the end point defined by FDL
		/// </summary>
		public string FDLNamespace { get; set; }

		/// <summary>Step name of the end point defined by FDL
		/// </summary>
		public string FDLStepName { get; set; }

		/// <summary>Pin name of the end point defined by FDL
		/// </summary>
		public string FDLPinName { get; set; }

		/// <summary>The full name of the endpoint in format Namespace.StepName.PinName
		/// </summary>
		public string FullName
		{
			get { return string.Concat(FDLNamespace, ".", FDLStepName, ".", FDLPinName); }
		}

		/// <summary>The full name of the step in format Namespace.StepName
		/// </summary>
		public string FullStepName
		{
			get { return string.Concat(FDLNamespace, ".", FDLStepName); }
		}
	}
}
