﻿using System.Collections.Generic;

namespace AB3.DataTypes
{
	/// <summary>Direction of the interface definition
	/// </summary>
	public enum Directions
	{
		/// <summary>Incoming
		/// </summary>
		In,

		/// <summary>Outgoing
		/// </summary>
		Out
	}

	/// <summary>Datatype to store an interface definition of a flow
	/// </summary>
	public class FDLInterfaceDefinition
	{
		/// <summary>Name of the interface
		/// </summary>
		public string Name { get; set; }

		/// <summary>Line number of the interface
		/// </summary>
		public int LineNumber { get; set; }

		/// <summary>Range of the interface content
		/// </summary>
		public FDLTextRange Range { get; set; }

		/// <summary>Direction of the interface
		/// </summary>
		public Directions Direction { get; set; }
		
		/// <summary>Additional attribute
		/// </summary>
		public Dictionary<string, FDLAttribute> Attributes { get; set; }

		/// <summary>Creates new interface definition instance
		/// </summary>
		public FDLInterfaceDefinition()
		{
			Range = new FDLTextRange();
			Attributes = new Dictionary<string, FDLAttribute>();
		}
	}
}
