﻿using System.Collections.Generic;

namespace AB3.DataTypes
{
	/// <summary>DataType to store all steps of a flow defined in FDL
	/// </summary>
	public class FDLSteps
	{
		/// <summary>Range of the steps
		/// </summary>
		public FDLTextRange Range { get; set; }

		/// <summary>Steps of the flow. Caption or Name is the key
		/// </summary>
		public Dictionary<string, FDLStepDefinition> Collection { get; set; }

		/// <summary>Creates new instance
		/// </summary>
		public FDLSteps()
		{
			Range = new FDLTextRange();
			Collection = new Dictionary<string, FDLStepDefinition>();
		}
	}
}
