﻿using System;

namespace AB3.Patterns
{
	/// <summary>Converts an argument to nothing to be used as trigger
	/// </summary>
	public class ConvertToTrigger<T>
	{
		/// <summary>Emit the trigger
		/// </summary>
		/// <param name="arg">The argument (unused and ignored!)</param>
		public void In_Input(T arg)
		{
			Out_Output();
		}

		/// <summary>Trigger output
		/// </summary>
		public event Action Out_Output;
	}
}
