﻿using System;
using System.Text;
using System.Collections.Generic;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.Text.RegularExpressions;
using AB3.DataTypes;

namespace AB3.AppBuilderTests
{
	/// <summary>
	/// Summary description for RegexTest1
	/// </summary>
	[TestClass]
	public class RegexTest1
	{
		public RegexTest1()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		private TestContext testContextInstance;

		/// <summary>
		///Gets or sets the test context which provides
		///information about and functionality for the current test run.
		///</summary>
		public TestContext TestContext
		{
			get
			{
				return testContextInstance;
			}
			set
			{
				testContextInstance = value;
			}
		}

		#region Additional test attributes
		//
		// You can use the following additional attributes as you write your tests:
		//
		// Use ClassInitialize to run code before running the first test in the class
		// [ClassInitialize()]
		// public static void MyClassInitialize(TestContext testContext) { }
		//
		// Use ClassCleanup to run code after all tests in a class have run
		// [ClassCleanup()]
		// public static void MyClassCleanup() { }
		//
		// Use TestInitialize to run code before running each test 
		// [TestInitialize()]
		// public void MyTestInitialize() { }
		//
		// Use TestCleanup to run code after each test has run
		// [TestCleanup()]
		// public void MyTestCleanup() { }
		//
		#endregion

		[TestMethod]
		public void TestMethod1()
		{
			var input = "{key1=\"value1\" key2=\"value2\"key3=\"value3\" key4=\"value4\" }";
			//Console.WriteLine(input);
			// key1="value1" key2="value2"key3="value3" key4="value4"

			Regex r = new Regex(@"(?<Key>[^{0}]*)(?:{0})(?<Value>[^{1}]*)(?:{1}?)", RegexOptions.IgnorePatternWhitespace);

			DSLAttribute tAttribute;
			List<DSLAttribute> tAttributes = new List<DSLAttribute>();
			foreach (Match m in r.Matches(input))
			{
				tAttribute = new DSLAttribute();
				tAttribute.Name = m.Groups[1].Value;
				tAttribute.Value = m.Groups[2].Value;
				tAttributes.Add(tAttribute);
				//Console.WriteLine(m);
			}

			Assert.AreEqual(4, tAttributes.Count);
		}

		[TestMethod]
		public void TestMethod2()
		{
			Dictionary<string, string> hashTable = new Dictionary<string, string>();

			string myString = "Caption = \"The main flow of the application\"Width=\"100\" Height= \"40\" Top = \"100\" Left =\"800\" }";
			//string pattern = @"([A-Za-z0-9]+)(\s*)(=)(\s*)("")([^""]*)("")";
			string pattern = @"(\w+)(\s*)(=)(\s*)("")([^""]*)("")";

			MatchCollection matches = Regex.Matches(myString, pattern);
			foreach (Match m in matches)
			{
				string key = m.Groups[1].Value;    // ([A-Za-z0-9]+)
				string value = m.Groups[6].Value;    // ([^""]*)

				hashTable[key] = value;
			}

			Assert.AreEqual(5, hashTable.Count);
		}
	}
}
