﻿using System;
using System.IO;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace AB3.AppBuilderTests
{
	[TestClass]
	public class Transform3Tests
	{
		private string _DSLFolder;
		private string _FlowFile;
		private string _LogFile;

		public Transform3Tests()
		{
			_DSLFolder = @"F:\Visual Studio Projects\AB3.AppBuilder\AB3.Iteration.10.04\AB3.DSLs";
			_FlowFile = Path.Combine(_DSLFolder, "DJP.ab3");
			_LogFile = @"F:\Visual Studio Projects\AB3.AppBuilder\AB3.AppBuilder.log";
		}

		[TestMethod]
		public void AddDJPFromABFileTestMethod1()
		{
			AppBuilder tAppBuilder = new AppBuilder(_LogFile, 2);
			tAppBuilder.LoadFlowsFromFile(_FlowFile);

			int tFlowDefinitions = tAppBuilder._AppDefinition.FlowDefinitions.Count;

			Assert.AreNotEqual(0, tFlowDefinitions);
		}

		[TestMethod]
		public void AddDJPFromABFileTestMethod2()
		{
			AppBuilder tAppBuilder = new AppBuilder(_LogFile, 2);
			tAppBuilder.LoadFlowsFromFile(_FlowFile);

			Assert.AreEqual(0, tAppBuilder._AppDefinition.ParseExceptions.Count);
		}

		[TestMethod]
		public void AddDJPFromABFileTestMethod3()
		{
			AppBuilder tAppBuilder = new AppBuilder();
			tAppBuilder.LoadFlowsFromFile(_FlowFile);

			Assert.AreEqual(0, tAppBuilder._AppDefinition.ParseExceptions.Count);
		}

		[TestMethod]
		public void BuildDJPAppTestMethod1()
		{
			AppBuilder tAppBuilder = new AppBuilder(_LogFile, 2);
			tAppBuilder.LoadFlowsFromFile(_FlowFile);
			tAppBuilder.BuildApp(null, null);

			Assert.AreNotEqual(0, tAppBuilder._AppDefinition.StepInstanceConnections.Count);
		}
	}
}
