﻿using System.Collections.Generic;
using System.Windows.Controls;
using AB3.DataTypes;

namespace AB3.AppDesigner.DataTypes
{
	public class ChartDefinition
	{
		/// <summary>The container of the controls
		/// </summary>
		public Grid Parent { get; private set; }

		/// <summary>The flow definition of the chart
		/// </summary>
		public FDLFlowDefinition FlowDefintion { get; private set; }

		/// <summary>The renderer remarks of flow definition
		/// </summary>
		public Dictionary<string, TextBlock> Remarks { get; set; }

		/// <summary>The renderer interfaces of flow definition
		/// </summary>
		public Dictionary<string, Border> Interfaces { get; set; }

		/// <summary>The rendered steps of the flow definition
		/// </summary>
		public Dictionary<string, Border> Steps { get; set; }

		public ChartDefinition(Grid parent, FDLFlowDefinition flowDefinition)
		{
			Parent = parent;
			FlowDefintion = flowDefinition;
			Remarks = new Dictionary<string, TextBlock>();
			Interfaces = new Dictionary<string, Border>();
			Steps = new Dictionary<string, Border>();
		}
	}
}
