﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Timers;
using AB3.AppDesigner.DataTypes;

namespace AB3.AppDesigner.Logic
{
	public class BackgroundScheduler
	{
		private DateTime _ModDat;
		private string _ChangedText;
		private Timer _TimeToCheckTimer;

		public BackgroundScheduler()
		{
			this._ModDat = DateTime.Now;
			this._ChangedText = null;
			this._TimeToCheckTimer = new Timer(500);
			this._TimeToCheckTimer.Elapsed += TimeToCheckTimer_Elapsed;
		}

		private void TimeToCheckTimer_Elapsed(object sender, ElapsedEventArgs e)
		{			
			double tElapsedSeconds = DateTime.Now.Subtract(this._ModDat).TotalSeconds;
			if ((tElapsedSeconds > 2) && (!string.IsNullOrEmpty(this._ChangedText)))
			{
				this._TimeToCheckTimer.Stop();
				Document tDocToCheck = new Document(string.Empty);
				tDocToCheck.Lines = this._ChangedText.Split(new string[] { Environment.NewLine }, StringSplitOptions.None);
				tDocToCheck.Application = new AB3.DataTypes.AppDefinition();
				tDocToCheck.Application.ErrorLogger = new AB3.Logging.LogToNoWhere();
				tDocToCheck.Application.ProgressLogger = tDocToCheck.Application.ErrorLogger;
				tDocToCheck.Application.BasicLogger = tDocToCheck.Application.ErrorLogger;
				tDocToCheck.Application.FlowText = new List<string>(tDocToCheck.Lines);
				this.Out_Document(tDocToCheck);
			}
		}

		public void In_DocumentChanged(string text)
		{
			this._ModDat = DateTime.Now;
			this._ChangedText = text;

			if (!this._TimeToCheckTimer.Enabled)
				this._TimeToCheckTimer.Start();
		}

		public event Action<Document> Out_Document;
	}
}
