﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using AB3.Interfaces;
using AB3.AppDesigner.DataTypes;

namespace AB3.AppDesigner.Logic
{
	public class DocumentLoader: IInitialize
	{
		public void In_LoadFile(string fileName)
		{
			if (File.Exists(fileName))
			{
				AppConfig.Instance.SetValue("LastFileName", fileName);

				Document tDocument = new Document(fileName);
				tDocument.Lines = File.ReadAllLines(fileName);
				tDocument.Application = new AB3.DataTypes.AppDefinition();
				tDocument.Application.ErrorLogger = new AB3.Logging.LogToNoWhere();
				tDocument.Application.ProgressLogger = tDocument.Application.ErrorLogger;
				tDocument.Application.BasicLogger = tDocument.Application.ErrorLogger;
				tDocument.Application.FlowText = new List<string>(File.ReadAllLines(fileName));
				this.Out_Document(tDocument);
			}
		}

		public event Action<Document> Out_Document;

		#region IInitialize
		public void Initialize(object args)
		{
			string tLastFileName = AppConfig.Instance.GetValueAsString("LastFileName");
			if (!string.IsNullOrEmpty(tLastFileName))
				this.In_LoadFile(tLastFileName);
		}
		#endregion
	}
}
