﻿using System;
using AB3.AppDesigner.DataTypes;

namespace AB3.AppDesigner.Logic
{
	public class DocumentParser
	{
		public event Action<Document> Out_Document;

		public void In_Document(Document document)
		{
			AB3.Steps.FDLTabReplacer tTabReplacer = new AB3.Steps.FDLTabReplacer();
			AB3.Steps.FDLFlowDefinitionsParser tFlowsFinder = new AB3.Steps.FDLFlowDefinitionsParser();
			AB3.Steps.FDLRemarkDefinitionsParser tRemarksFinder = new AB3.Steps.FDLRemarkDefinitionsParser();
			AB3.Steps.FDLStepDefinitionsParser tStepsFinder = new AB3.Steps.FDLStepDefinitionsParser();
			AB3.Steps.FDLInterfaceDefinitionsParser tInterfacesFinder = new AB3.Steps.FDLInterfaceDefinitionsParser();
			AB3.Steps.FDLWireDefinitionsParser tConnectionsFinder = new AB3.Steps.FDLWireDefinitionsParser();
			AB3.Steps.FDLAttributeDefinitionsParser tAttributeParser = new Steps.FDLAttributeDefinitionsParser();

			tTabReplacer.Out_Output += tFlowsFinder.In_Input;
			tFlowsFinder.Out_Output += tRemarksFinder.In_Input;
			tRemarksFinder.Out_Output += tStepsFinder.In_Input;
			tStepsFinder.Out_Output += tInterfacesFinder.In_Input;
			tInterfacesFinder.Out_Output += tConnectionsFinder.In_Input;
			tConnectionsFinder.Out_Output += tAttributeParser.In_Input;
			tAttributeParser.Out_Output += this.In_StepFinished;

			tTabReplacer.In_Input(document.Application);

			this.Out_Document(document);
		}

		public void In_StepFinished(AB3.DataTypes.AppDefinition app)
		{
			// End of AppBuilder Steps
		}
	}
}
