﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using AB3.DataTypes;
using AB3.AppDesigner.DataTypes;

namespace AB3.AppDesigner.Logic
{
	public class PinFinder
	{
		public void In_Component(Document document, string componentName)
		{
			if (componentName.StartsWith("Flow:"))
			{
				string tName = componentName.Replace("Flow: ", string.Empty);
				if (document.Application.FlowDefinitions.ContainsKey(tName))
				{
					this.Out_Output(document.Application.FlowDefinitions[tName].Interfaces.Collection.Values);
				}
			}
			else if (componentName.StartsWith("Step:"))
			{
				string tName = componentName.Replace("Step: ", string.Empty);
				Dictionary<string, FDLInterfaceDefinition> tInterfaces = new Dictionary<string, FDLInterfaceDefinition>();

				foreach (FDLFlowDefinition tFlowDefinition in document.Application.FlowDefinitions.Values)
				{
					foreach (FDLStepDefinition tStepDefinition in tFlowDefinition.Steps.Collection.Values)
					{
						if ((tStepDefinition.CustomName == tName) || (tStepDefinition.TypeName == tName))
						{
							// OK! Step is used in Flow:
							foreach (FDLWireDefinition tWireDefiniton in tFlowDefinition.Wires.Collection)
							{
								if (tWireDefiniton.Source.Step == tStepDefinition.CustomName)
								{
									if (!tInterfaces.ContainsKey(tWireDefiniton.Source.Pin))
									{
										FDLInterfaceDefinition tInterfaceDefinition = new FDLInterfaceDefinition();
										tInterfaceDefinition.Direction = Directions.Out;
										tInterfaceDefinition.Name = tWireDefiniton.Source.Pin;
										tInterfaces.Add(tInterfaceDefinition.Name, tInterfaceDefinition);
									}
								}
								if (tWireDefiniton.Target.Step == tStepDefinition.CustomName)
								{
									if (!tInterfaces.ContainsKey(tWireDefiniton.Target.Pin))
									{
										FDLInterfaceDefinition tInterfaceDefinition = new FDLInterfaceDefinition();
										tInterfaceDefinition.Direction = Directions.In;
										tInterfaceDefinition.Name = tWireDefiniton.Target.Pin;
										tInterfaces.Add(tInterfaceDefinition.Name, tInterfaceDefinition);
									}
								}
							}
						}
					}
				}

				Out_Output(tInterfaces.Values);
			}			
		}

		public event Action<IEnumerable<FDLInterfaceDefinition>> Out_Output;
	}
}
