﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Shapes;
using AB3.AppDesigner.Converters;
using AB3.AppDesigner.DataTypes;
using AB3.DataTypes;

namespace AB3.AppDesigner.Presenters
{
	public class DesignerPresenter
	{
		private Document _Document;
		private FDLFlowDefinition _CurrentFlowDefinition;

		public void In_Document(Document document)
		{
			_Document = document;
			if (_CurrentFlowDefinition != null)
			{
				if (_Document.Application.FlowDefinitions.ContainsKey(_CurrentFlowDefinition.Name))
				{
					_CurrentFlowDefinition = _Document.Application.FlowDefinitions[_CurrentFlowDefinition.Name];
					StartRendering(_CurrentFlowDefinition);
				}
			}
			else if (document.Application.FlowDefinitions.ContainsKey("MainFlow"))
			{
				_CurrentFlowDefinition = document.Application.FlowDefinitions["MainFlow"];
				StartRendering(_CurrentFlowDefinition);
			}
		}

		public void In_NavigateToFlow(FDLFlowDefinition flowDefinition)
		{
			_CurrentFlowDefinition = flowDefinition;
			StartRendering(_CurrentFlowDefinition);
		}

		private void StartRendering(FDLFlowDefinition flowDefinition)
		{
			if (!MainWindow.Instance.gridDesigner.CheckAccess())
			{
				MainWindow.Instance.gridDesigner.Dispatcher.Invoke(new Action<FDLFlowDefinition>(StartRendering), flowDefinition);
			}
			else
			{
				MainWindow.Instance.gridDesigner.Children.Clear();
				MainWindow.Instance.textBlockDesignerFlowDefinition.Text = string.Concat("FlowDefinition: ", flowDefinition.Name);
				ChartDefinition tChartDefinition = new ChartDefinition(MainWindow.Instance.gridDesigner, flowDefinition);
				Out_Output(tChartDefinition);
			}
		}

		public event Action<ChartDefinition> Out_Output;
	}
}
