﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using AB3.DataTypes;
using AB3.Interfaces;
using AB3.AppDesigner.DataTypes;

namespace AB3.AppDesigner.Presenters
{
	public class ExceptionPresenter: IInitialize
	{
		public void In_Document(Document document)
		{
			if (MainWindow.Instance.listViewExceptions.CheckAccess())
			{
				MainWindow.Instance.listViewExceptions.ItemsSource = document.Application.ParseExceptions;
			}
			else
				MainWindow.Instance.listViewExceptions.Dispatcher.Invoke(new Action<Document>(In_Document), document);
		}

		public event Action<FDLException> Out_ExceptionSelected;

		#region Events from UI
		private void listViewExceptions_MouseDoubleClick(object sender, System.Windows.Input.MouseButtonEventArgs e)
		{
			if (MainWindow.Instance.listViewExceptions.SelectedItems.Count == 1)
			{
				FDLException tException = (FDLException)MainWindow.Instance.listViewExceptions.SelectedItem;

				this.Out_ExceptionSelected(tException);
			}
		}
		#endregion

		#region IInitialize
		public void Initialize(object args)
		{
			MainWindow.Instance.listViewExceptions.MouseDoubleClick += listViewExceptions_MouseDoubleClick;
		}		
		#endregion
	}
}
