﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using AB3.Interfaces;
using AB3.AppDesigner.DataTypes;

namespace AB3.AppDesigner.Presenters
{
	public class LayoutPresenter: IInitialize
	{
		#region IInitialize
		public void Initialize(object args)
		{
			GridLength tGridLength;

			tGridLength = new GridLength(AppConfig.Instance.GetValueAsDouble("PinUsageHeight"));
			MainWindow.Instance.gridRowPinUsage.Height = tGridLength;

			tGridLength = new GridLength(AppConfig.Instance.GetValueAsDouble("ComponentsWidth"));
			MainWindow.Instance.gridColumnDefinitionComponents.Width = tGridLength;
		
			tGridLength = new GridLength(AppConfig.Instance.GetValueAsDouble("DocumentOutlineWidth"));
			MainWindow.Instance.gridColumnDefinitionDocumentOutline.Width = tGridLength;

			tGridLength = new GridLength(AppConfig.Instance.GetValueAsDouble("ExceptionsHeight"));
			MainWindow.Instance.gridRowDefinitionExceptions.Height = tGridLength;
			
			MainWindow.Instance.Closing += MainWindowInstance_Closing;

			MainWindow.Instance.textEditor.FontSize = AppConfig.Instance.GetValueAsDouble("FontSize");
			MainWindow.Instance.buttonSizeMinus.Click += buttonSizeMinus_Click;
			MainWindow.Instance.buttonSizePlus.Click += buttonSizePlus_Click;
		}
		#endregion

		#region Events From UI: Button Minus/Plus Click
		private void buttonSizeMinus_Click(object sender, RoutedEventArgs e)
		{
			MainWindow.Instance.textEditor.FontSize--;
			AppConfig.Instance.SetValue("FontSize", MainWindow.Instance.textEditor.FontSize);
		}

		private void buttonSizePlus_Click(object sender, RoutedEventArgs e)
		{
			MainWindow.Instance.textEditor.FontSize++;
			AppConfig.Instance.SetValue("FontSize", MainWindow.Instance.textEditor.FontSize);
		}
		#endregion

		private void MainWindowInstance_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			AppConfig.Instance.SetValue("PinUsageHeight", MainWindow.Instance.gridRowPinUsage.Height.Value);
			AppConfig.Instance.SetValue("ComponentsWidth", MainWindow.Instance.gridColumnDefinitionComponents.Width.Value);
			AppConfig.Instance.SetValue("DocumentOutlineWidth", MainWindow.Instance.gridColumnDefinitionDocumentOutline.Width.Value);
			AppConfig.Instance.SetValue("ExceptionsHeight", MainWindow.Instance.gridRowDefinitionExceptions.Height.Value);
		}
	}
}
