﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using AB3.Interfaces;
using AB3.AppDesigner.DataTypes;

namespace AB3.AppDesigner.Presenters
{
	public class SavePresenter: IInitialize
	{
		private Document _Document;

		private void buttonSaveAs_Click(object sender, System.Windows.RoutedEventArgs e)
		{
			Microsoft.Win32.SaveFileDialog tSaveFileDialog = new Microsoft.Win32.SaveFileDialog();
			tSaveFileDialog.DefaultExt = ".ab3";
			tSaveFileDialog.Filter = "AppBuilder V3 definitions|*.ab3|All Documents|*.*";

			if (!string.IsNullOrEmpty(this._Document.FileName))
			{
				tSaveFileDialog.InitialDirectory = Path.GetDirectoryName(this._Document.FileName);
				tSaveFileDialog.FileName = Path.GetFileName(this._Document.FileName);
			}
			Nullable<bool> tDialogResult = tSaveFileDialog.ShowDialog();

			if (tDialogResult == true)
			{
				this._Document.FileName = tSaveFileDialog.FileName;
				MainWindow.Instance.Title = "AB3.AppDesigner: " + this._Document.FileName;
				File.WriteAllText(this._Document.FileName, this._Document.Text);
				MainWindow.Instance.buttonSave.IsEnabled = true;
				AppConfig.Instance.SetValue("LastFileName", this._Document.FileName);
			}
		}

		private void buttonSave_Click(object sender, System.Windows.RoutedEventArgs e)
		{
			if (this._Document.Text != null)
				File.WriteAllText(this._Document.FileName, this._Document.Text);
		}

		public void In_Document(Document document)
		{
			this._Document = document;
			if (string.IsNullOrEmpty(document.FileName))
			{
				MainWindow.Instance.Title = "EBC.AppDesigner: (New Document!)";
				MainWindow.Instance.buttonSave.IsEnabled = false;
			}
			else
				MainWindow.Instance.Title = "EBC.AppDesigner: " + this._Document.FileName;
		}

		#region IInitialize
		public void Initialize(object args)
		{
			MainWindow.Instance.buttonSave.Click += buttonSave_Click;
			MainWindow.Instance.buttonSaveAs.Click += buttonSaveAs_Click;
		}
		#endregion
	}
}
