﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using AB3.DataTypes;
using AB3.Interfaces;

namespace AB3.AppDesigner.Presenters
{
	public class UsagePresenter : IInitialize
	{
		public void In_Input(IEnumerable<FDLFlowDefinition> boardDefinitions)
		{
			MainWindow.Instance.listUsage.ItemsSource = boardDefinitions;
		}

		public event Action<FDLFlowDefinition> Out_FlowSelected;

		public void Initialize(object args)
		{
			MainWindow.Instance.listUsage.MouseDoubleClick += listUsage_MouseDoubleClick;

			MainWindow.Instance.listUsage.Items.SortDescriptions.Add(
				new System.ComponentModel.SortDescription("BoardName",
					System.ComponentModel.ListSortDirection.Ascending));
		}

		private void listUsage_MouseDoubleClick(object sender, System.Windows.Input.MouseButtonEventArgs e)
		{
			if (MainWindow.Instance.listUsage.SelectedItems.Count == 1)
			{
				FDLFlowDefinition tSelectedItem = MainWindow.Instance.listUsage.SelectedItem as FDLFlowDefinition;
				if (tSelectedItem != null)
					this.Out_FlowSelected(tSelectedItem);
			}
		}
	}
}
