﻿using System;
using System.Collections.Generic;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using AB3.AppDesigner.Converters;
using AB3.AppDesigner.DataTypes;
using AB3.DataTypes;
using AB3.Interfaces;

namespace AB3.AppDesigner.RenderFlow
{
	public class InterfacesRenderer
	{
		public void In_Input(ChartDefinition chartDefinition)
		{
			if (!chartDefinition.Parent.CheckAccess())
			{
				chartDefinition.Parent.Dispatcher.Invoke(new Action<ChartDefinition>(In_Input), chartDefinition);
			}
			else
			{
				SolidColorBrush tBlackBrush = new SolidColorBrush(Colors.Black);
				SolidColorBrush tGreenBrush = new SolidColorBrush(Colors.LightGreen);
				Thickness tBorderThickness = new Thickness(2);
				CornerRadius tCornerRadius = new CornerRadius(8);

				foreach (FDLInterfaceDefinition tInterfaceDefinition in chartDefinition.FlowDefintion.Interfaces.Collection.Values)
				{
					TextBlock tTextBlock = new TextBlock();
					tTextBlock.Text = tInterfaceDefinition.Name;
					tTextBlock.TextWrapping = TextWrapping.NoWrap;
					Border tBorder = new Border();
					tBorder.Child = tTextBlock;
					tBorder.BorderBrush = tBlackBrush;
					tBorder.Background = tGreenBrush;
					tBorder.BorderThickness = tBorderThickness;
					tBorder.CornerRadius = tCornerRadius;
					tBorder.Margin = FDLAttributeConverter.ToPosition(tInterfaceDefinition.Attributes, 10, 50); 
					tBorder.HorizontalAlignment = HorizontalAlignment.Left;
					tBorder.VerticalAlignment = VerticalAlignment.Top;
					FDLAttributeConverter.SetSize(tInterfaceDefinition.Attributes, tBorder, 100, 25);
					chartDefinition.Interfaces.Add(tInterfaceDefinition.Name, tBorder);
					chartDefinition.Parent.Children.Add(tBorder);
				}
			}

			Out_Output(chartDefinition);
		}

		public event Action<ChartDefinition> Out_Output;
	}
}
