﻿using System;
using System.Collections.Generic;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using AB3.AppDesigner.Converters;
using AB3.AppDesigner.DataTypes;
using AB3.DataTypes;
using AB3.Interfaces;

namespace AB3.AppDesigner.RenderFlow
{
	public class RemarksRenderer
	{
		public void In_Input(ChartDefinition chartDefinition)
		{
			if (!chartDefinition.Parent.CheckAccess())
			{
				chartDefinition.Parent.Dispatcher.Invoke(new Action<ChartDefinition>(In_Input), chartDefinition);
			}
			else
			{
				SolidColorBrush tYellowBrush = new SolidColorBrush(Colors.Yellow);
				SolidColorBrush tBlackBrush = new SolidColorBrush(Colors.Black);
				Thickness tBorderThickness = new Thickness(1);
				Thickness tPaddingThickness = new Thickness(2);

				foreach (FDLRemarkDefinition tRemark in chartDefinition.FlowDefintion.Remarks.Collection.Values)
				{
					TextBlock tTextBlock = new TextBlock();
					tTextBlock.Padding = tPaddingThickness;
					if (tRemark.Attributes.ContainsKey("Caption"))
						tTextBlock.Text = tRemark.Attributes["Caption"].Value;
					else
						tTextBlock.Text = "No caption!";

					tTextBlock.Background = tYellowBrush;
					tTextBlock.TextWrapping = TextWrapping.Wrap;
					Border tBorder = new Border();
					tBorder.Child = tTextBlock;
					tBorder.BorderBrush = tBlackBrush;
					tBorder.BorderThickness = tBorderThickness;
					tBorder.Margin = FDLAttributeConverter.ToPosition(tRemark.Attributes, 10, 10);
					tBorder.HorizontalAlignment = HorizontalAlignment.Left;
					tBorder.VerticalAlignment = VerticalAlignment.Top;
					FDLAttributeConverter.SetSize(tRemark.Attributes, tBorder, 100, 50);
					chartDefinition.Remarks.Add(tRemark.Name, tTextBlock);
					chartDefinition.Parent.Children.Add(tBorder);
				}
			}

			Out_Output(chartDefinition);
		}

		public event Action<ChartDefinition> Out_Output;
	}
}
