﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using AB3.DataTypes;
using AB3.AppDesigner.DataTypes;

namespace AB3.AppDesigner.Validators
{
	public class ValidateIfFlowIsUsed
	{
		public void In_Document(Document document)
		{
			foreach (FDLFlowDefinition tFlowDefinition in document.Application.FlowDefinitions.Values)
			{
				if (tFlowDefinition.Name != "MainFlow")
				{
					bool tBoardIsUsed = false;
					foreach (FDLFlowDefinition tUsedInFlowDefinition in document.Application.FlowDefinitions.Values)
					{
						foreach (FDLStepDefinition tStepDefinition in tUsedInFlowDefinition.Steps.Collection.Values)
						{
							if ((tStepDefinition.TypeName == tFlowDefinition.Name) && (tStepDefinition.IsSubFlowStep))
							{
								tBoardIsUsed = true;
								break;
							}
						}

						if (tBoardIsUsed)
							break;
					}

					if (!tBoardIsUsed)
					{
						FDLException tEx = new FDLException("Unused flow detected!",
							tFlowDefinition.Range.StartLine + 1, document.Application.FlowText[tFlowDefinition.Range.StartLine]);
						document.Application.ParseExceptions.Add(tEx);
					}
				}
			}

			Out_Document(document);
		}

		public event Action<Document> Out_Document;
	}
}
