﻿using System;
using AB3.AppDesigner.DataTypes;
using AB3.DataTypes;

namespace AB3.AppDesigner.Validators
{
	public class ValidateIfStepsAreDefinedAsFlow
	{
		public void In_Document(Document document)
		{
			foreach (FDLFlowDefinition tFlowDefinition in document.Application.FlowDefinitions.Values)
			{
				foreach (FDLStepDefinition tStepDefinition in tFlowDefinition.Steps.Collection.Values)
				{
					if ((!tStepDefinition.IsSubFlowStep) && (document.Application.FlowDefinitions.ContainsKey(tStepDefinition.TypeName)))
					{
						FDLException tEx = new FDLException("Flow is used as step",
							tStepDefinition.LineNumber + 1, document.Application.FlowText[tStepDefinition.LineNumber]);
						document.Application.ParseExceptions.Add(tEx);
					}
				}
			}

			Out_Document(document);
		}

		public event Action<Document> Out_Document;
	}
}
