﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using AB3.DataTypes;
using AB3.AppDesigner.DataTypes;

namespace AB3.AppDesigner.Validators
{
	public class ValidateIfSubFlowsExist
	{
		public void In_Document(Document document)
		{
			string tMessage;
			foreach (FDLFlowDefinition tFlowDefinition in document.Application.FlowDefinitions.Values)
			{
				foreach (FDLStepDefinition tStepDefinition in tFlowDefinition.Steps.Collection.Values)
				{
					if (tStepDefinition.IsSubFlowStep)
					{
						if (!document.Application.FlowDefinitions.ContainsKey(tStepDefinition.TypeName))
						{
							tMessage = string.Format("Step with type name '{0}' is missing!", tStepDefinition.TypeName);
							FDLException tEx = new FDLException(tMessage,
								tStepDefinition.LineNumber + 1, document.Lines[tStepDefinition.LineNumber]);
							document.Application.ParseExceptions.Add(tEx);
						}
					}
				}
			}

			Out_Document(document);
		}

		public event Action<Document> Out_Document;
	}
}
