﻿using System;
using AB3.AppDesigner.DataTypes;

namespace AB3.AppDesigner.Validators
{
	public class ValidateMainFlow
	{
		public void In_Document(Document document)
		{
			if (!document.Application.FlowDefinitions.ContainsKey("MainFlow"))
			{
				AB3.DataTypes.FDLException tEx = new AB3.DataTypes.FDLException("MainFlow is missing!", 1, string.Empty);
				document.Application.ParseExceptions.Add(tEx);
			}
			else
			{
				AB3.DataTypes.FDLFlowDefinition tMainFlow = document.Application.FlowDefinitions["MainFlow"];

				#region MainFlow may not have any interfaces
				if (tMainFlow.Interfaces.Collection.Count != 0)
				{
					AB3.DataTypes.FDLException tEx = new AB3.DataTypes.FDLException("MainFlow may not have any interfaces!",
						tMainFlow.Interfaces.Range.StartLine + 1,
						document.Lines[tMainFlow.Interfaces.Range.StartLine]);
					document.Application.ParseExceptions.Add(tEx);
				}
				#endregion
			}

			this.Out_Document(document);
		}

		public event Action<Document> Out_Document;
	}
}
