﻿using System;

namespace AB3.TestTimer
{
    public class TimerPart
    {
        private DateTime _AlarmTime = DateTime.MaxValue;

        #region NewTime
        public void In_NewTime(DateTime value)
        {
            if (value >= _AlarmTime)
            {
                this.Out_AlarmTimeReached(_AlarmTime);
            }
            else
            {
                if (_AlarmTime != DateTime.MaxValue)
                {
                    TimeSpan tTimeLeft = _AlarmTime - value;
                    this.Out_TimeLeft(tTimeLeft);
                }
            }
        }
        #endregion

        #region SetAlarmTime
        public void In_SetAlarmTime(double seconds)
        {
            _AlarmTime = DateTime.Now.AddSeconds(seconds);
        }
        #endregion

        #region ResetAlarmTime
        public void In_ResetAlarmTime()
        {
            _AlarmTime = DateTime.MaxValue;
        }
        #endregion

        #region AlarmTimeReached
        public event Action<DateTime> Out_AlarmTimeReached;
        #endregion

        #region TimeLeft
        public event Action<TimeSpan> Out_TimeLeft;
        #endregion
    }
}
