﻿
namespace AB3.DataTypes
{
	/// <summary>DataType to store a single flow definition with all its content
	/// </summary>
	public class FDLFlowDefinition
	{
		/// <summary>Name of the flow
		/// </summary>
		public string Name { get; set; }

		/// <summary>Range of the flow
		/// </summary>
		public FDLTextRange Range { get; set; }

		/// <summary>Steps of the flow
		/// </summary>
		public FDLSteps Steps { get; set; }

		/// <summary>Interfaces of the flow
		/// </summary>
		public FDLInterfaces Interfaces { get; set; }

		/// <summary>Remarks of the flow
		/// </summary>
		public FDLRemarks Remarks { get; set; }

		/// <summary>Connections of the flow
		/// </summary>
		public FDLWires Wires { get; set; }

		/// <summary>Creates a new instance
		/// </summary>
		public FDLFlowDefinition()
		{
			Name = string.Empty;
			Range = new FDLTextRange();
			Steps = new FDLSteps();
			Remarks = new FDLRemarks();
			Interfaces = new FDLInterfaces();
			Wires = new FDLWires();
		}

		/// <summary>Returns the name and the text range in FDL of the flow definition
		/// </summary>
		/// <returns>For example: Name = TheName, from 1 to 99</returns>
		public override string ToString()
		{
			return string.Format("Name = '{0}', from {1} to {2}",
				Name, Range.StartLine, Range.EndLine);
		}
	}
}
