﻿using System.Collections.Generic;

namespace AB3.DataTypes
{
	/// <summary>DataType to store a single remark definition of the FDL
	/// </summary>
	public class FDLRemarkDefinition
	{
		/// <summary>Name of the remark
		/// </summary>
		public string Name { get; set; }

		/// <summary>Range of the remark
		/// </summary>
		public FDLTextRange Range { get; set; }
		
		/// <summary>Additional attribute
		/// (Key = Name of the attribute)
		/// </summary>
		public Dictionary<string, FDLAttribute> Attributes { get; set; }

		/// <summary>Creates new instance
		/// </summary>
		public FDLRemarkDefinition()
		{
			Attributes = new Dictionary<string, FDLAttribute>();
			Range = new FDLTextRange();
		}
	}
}
