﻿using System.Collections.Generic;

namespace AB3.DataTypes
{
	/// <summary>Definition of a single step
	/// </summary>
	public class FDLStepDefinition
	{
		/// <summary>type name of the step
		/// </summary>
		public string TypeName { get; set; }

		/// <summary>Custom name of the step of type name of the step (default)
		/// </summary>
		public string CustomName { get; set; }

		/// <summary>Line number where step was defined
		/// </summary>
		public int LineNumber { get; set; }

		/// <summary>Range of the step content
		/// </summary>
		public FDLTextRange Range { get; set; }

		/// <summary>This step is a subflow (Default = false)
		/// </summary>
		public bool IsSubFlowStep { get; set; }

		/// <summary>Additional attribute of the designer
		/// </summary>
		public Dictionary<string, FDLAttribute> Attributes { get; set; }

		/// <summary>Creates new instance
		/// </summary>
		public FDLStepDefinition()
		{
			Attributes = new Dictionary<string, FDLAttribute>();
			Range = new FDLTextRange();
			IsSubFlowStep = false;
		}
	}
}
