﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AB3.Patterns
{
	/// <summary>Asynchronizes by task for single type
	/// </summary>
	public class TaskAsynchronizer<T>
	{
		/// <summary>Starts the thread
		/// </summary>
		/// <param name="input">Input to send to the task</param>
		public void In_Input(T input)
		{
			Task.Factory.StartNew(() => Out_Output(input));
		}

		/// <summary>Sends the input
		/// </summary>
		public event Action<T> Out_Output;
	}

	/// <summary>Asynchronizes by task for two arguments
	/// </summary>
	public class TaskAsynchronizer<S,T>
	{
		/// <summary>Starts the thread
		/// </summary>
		/// <param name="input1">Input of type S to send to the task</param>
		/// <param name="input2">Input of type T to send to the task</param>
		public void In_Input(S input1, T input2)
		{
			Task.Factory.StartNew(() => Out_Output(input1, input2));
		}

		/// <summary>Sends the input
		/// </summary>
		public event Action<S, T> Out_Output;
	}
}
