﻿
namespace AB3.Patterns
{
	/// <summary>Type safe dead end of a signal
	/// </summary>
	/// <typeparam name="T">Type of the signal</typeparam>
	public class Terminator<T>
	{
		/// <summary>Dead end of a signal
		/// </summary>
		/// <param name="value">Value to terminate</param>
		public void In_Input(T value)
		{ }
	}

	/// <summary>Type safe dead end of a signal
	/// </summary>
	/// <typeparam name="S">Type of signal 1</typeparam>
	/// <typeparam name="T">Type of signal 2</typeparam>
	public class Terminator<S, T>
	{
		/// <summary>Dead end of a signal
		/// </summary>
		/// <param name="value1">Value 1 to terminate</param>
		/// <param name="value2">Value 2 to terminate</param>
		public void In_Input(S value1, T value2)
		{ }
	}
}
