﻿using AB3.DataTypes;
using AB3.Logging;

namespace AB3.Steps
{
	/// <summary>Generic Step terminator that simply sends a final message to logger
	/// </summary>
	public class StepsEnd
	{
		private string _EndMessage = string.Empty;

		/// <summary>Creates new instance ot step terminator
		/// </summary>
		/// <param name="finalMessage">Final message to send to logger</param>
		public StepsEnd(string finalMessage)
		{
			_EndMessage = finalMessage;
		}

		/// <summary>Pin that starts the logging of the final message
		/// </summary>
		/// <param name="app">Instance of App with the application definition</param>
		public void In_Input(AppDefinition app)
		{
			app.BasicLogger.LogInfo(_EndMessage);
			app.BasicLogger.LogInfo("------------------------------------");
		}
	}
}
