﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using AB3.AppDesigner.DataTypes;

namespace AB3.AppDesigner.Converters
{
	public class LinesToAppDefinitionConverter
	{
		public void In_Input()
		{
			AB3.Steps.FDLTabReplacer tTabReplacer = new AB3.Steps.FDLTabReplacer();
			AB3.Steps.FDLFlowDefinitionsParser tFlowsFinder = new AB3.Steps.FDLFlowDefinitionsParser();
			AB3.Steps.FDLRemarkDefinitionsParser tRemarksFinder = new AB3.Steps.FDLRemarkDefinitionsParser();
			AB3.Steps.FDLStepDefinitionsParser tStepsFinder = new AB3.Steps.FDLStepDefinitionsParser();
			AB3.Steps.FDLInterfaceDefinitionsParser tInterfacesFinder = new AB3.Steps.FDLInterfaceDefinitionsParser();
			AB3.Steps.FDLWireDefinitionsParser tConnectionsFinder = new AB3.Steps.FDLWireDefinitionsParser();
			AB3.Steps.FDLAttributeDefinitionsParser tAttributeParser = new Steps.FDLAttributeDefinitionsParser();

			tTabReplacer.Out_Output += tFlowsFinder.In_Input;
			tFlowsFinder.Out_Output += tRemarksFinder.In_Input;
			tRemarksFinder.Out_Output += tStepsFinder.In_Input;
			tStepsFinder.Out_Output += tInterfacesFinder.In_Input;
			tInterfacesFinder.Out_Output += tConnectionsFinder.In_Input;
			tConnectionsFinder.Out_Output += tAttributeParser.In_Input;
			tAttributeParser.Out_Output += this.In_StepFinished;

			AB3.DataTypes.AppDefinition tAppDefinition = new AB3.DataTypes.AppDefinition();
			tAppDefinition.FlowText = new List<string>(FileContentCache.Value);
			tTabReplacer.In_Input(tAppDefinition);

			AppDefinitionCache.Value = tAppDefinition;
			this.Out_Output();
		}

		private void In_StepFinished(AB3.DataTypes.AppDefinition app)
		{
			// End of AppBuilder Steps
		}

		public event Action Out_Output;
	}
}
