﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using AB3.AppDesigner.DataTypes;
using AB3.Interfaces;

namespace AB3.AppDesigner.EventHandlers
{
	public class SaveEventHandler: IInitialize
	{
		#region IInitialize
		public void Initialize(object args)
		{
			MainWindow.Instance.buttonSave.Click += buttonSave_Click;
			MainWindow.Instance.buttonSaveAs.Click += buttonSaveAs_Click;
		}
		#endregion

		private void buttonSaveAs_Click(object sender, System.Windows.RoutedEventArgs e)
		{
			Microsoft.Win32.SaveFileDialog tSaveFileDialog = new Microsoft.Win32.SaveFileDialog();
			tSaveFileDialog.DefaultExt = ".ab3";
			tSaveFileDialog.Filter = "AppBuilder V3 definitions|*.ab3|All Documents|*.*";

			if (!string.IsNullOrEmpty(FileNameCache.Value))
			{
				tSaveFileDialog.InitialDirectory = Path.GetDirectoryName(FileNameCache.Value);
				tSaveFileDialog.FileName = Path.GetFileName(FileNameCache.Value);
			}
			Nullable<bool> tDialogResult = tSaveFileDialog.ShowDialog();

			if (tDialogResult == true)
			{
				AppConfig.Instance.SetValue("LastFileName", tSaveFileDialog.FileName);
				FileNameCache.Value = tSaveFileDialog.FileName;
				Out_Output();
			}
		}

		private void buttonSave_Click(object sender, System.Windows.RoutedEventArgs e)
		{
			if (FileContentCache.Value.Count != 0)
				Out_Output();
		}

		public event Action Out_Output;
	}
}
