﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using AB3.AppDesigner.DataTypes;
using AB3.DataTypes;

namespace AB3.AppDesigner.Logic
{
	public class ChangeAllFlowStepDefinitions
	{
		public void In_Input(FDLStepDefinition stepDefinition, string newTypeName, string newCustomName)
		{
			StepChangeArgument tStepChangeArgument = new StepChangeArgument();
			tStepChangeArgument.OldCustomName = stepDefinition.CustomName;
			tStepChangeArgument.OldTypeName = stepDefinition.TypeName;

			// First change the source step because of the custom name.
			{
				FDLFlowDefinition tFlowDefinition = AppDefinitionCache.Value.FlowDefinitions[FlowDefinitionNameCache.Value];
				tFlowDefinition.Steps.Collection.Remove(stepDefinition.CustomName);
				stepDefinition.TypeName = newTypeName;
				if (string.IsNullOrEmpty(newCustomName))
					stepDefinition.CustomName = stepDefinition.TypeName;
				else
					stepDefinition.CustomName = newCustomName;

				tFlowDefinition.Steps.Collection.Add(stepDefinition.CustomName, stepDefinition);
				tStepChangeArgument.NewCustomName = stepDefinition.CustomName;
				tStepChangeArgument.NewTypeName = stepDefinition.TypeName;
			}

			// Second change to FlowDefinition itself
			if (AppDefinitionCache.Value.FlowDefinitions.ContainsKey(tStepChangeArgument.OldTypeName))
			{
				FDLFlowDefinition tFlowDefinition = AppDefinitionCache.Value.FlowDefinitions[tStepChangeArgument.OldTypeName];
				AppDefinitionCache.Value.FlowDefinitions.Remove(tStepChangeArgument.OldTypeName);
				tFlowDefinition.Name = newTypeName;
				AppDefinitionCache.Value.FlowDefinitions.Add(tFlowDefinition.Name, tFlowDefinition);
			}

			// Third change all flow steps of all flowdefinitions
			foreach (FDLFlowDefinition tFlowDefinition in AppDefinitionCache.Value.FlowDefinitions.Values)
			{
				List<FDLStepDefinition> tStepDefinitionsToChange = new List<FDLStepDefinition>();

				foreach (FDLStepDefinition tStepDefinition in tFlowDefinition.Steps.Collection.Values)
				{
					if (tStepDefinition.TypeName == tStepChangeArgument.OldTypeName)
						tStepDefinitionsToChange.Add(tStepDefinition);
				}

				foreach (FDLStepDefinition tStepDefinitionToChange in tStepDefinitionsToChange)
				{
					tFlowDefinition.Steps.Collection.Remove(tStepDefinitionToChange.CustomName);

					if (tStepDefinitionToChange.TypeName == tStepDefinitionToChange.CustomName)
					{
						tStepDefinitionToChange.TypeName = newTypeName;
						tStepDefinitionToChange.CustomName = newTypeName;
					}
					else
						tStepDefinitionToChange.TypeName = newTypeName;

					tFlowDefinition.Steps.Collection.Add(tStepDefinitionToChange.CustomName, tStepDefinitionToChange);
				}
			}

			Out_Output(tStepChangeArgument);
		}

		public event Action<StepChangeArgument> Out_Output;
	}
}
