﻿using System;
using AB3.AppDesigner.DataTypes;
using AB3.DataTypes;

namespace AB3.AppDesigner.Logic
{
	public class ChangeInterfaceWiresOfRelatedFlowDefinitions
	{
		public void In_Input(string oldName, string newName)
		{
			foreach (FDLFlowDefinition tFlowDefinition in AppDefinitionCache.Value.FlowDefinitions.Values)
			{
				// Only related flows
				if (tFlowDefinition.Name != FlowDefinitionNameCache.Value)
				{					
					foreach (FDLStepDefinition tStepDefinition in tFlowDefinition.Steps.Collection.Values)
					{
						// Does the flow using the current flow?
						if ((tStepDefinition.IsSubFlowStep) && (tStepDefinition.TypeName == FlowDefinitionNameCache.Value))
						{
							foreach (FDLWireDefinition tWire in tFlowDefinition.Wires.Collection)
							{
								// Is this the wireDefinition to current flow & the interface ?
								if ((tWire.Source.Step == tStepDefinition.CustomName) && (tWire.Source.Pin == oldName))
								{
									tWire.Source.Pin = newName;
								}
								else if ((tWire.Target.Step == tStepDefinition.CustomName) && (tWire.Target.Pin == oldName))
								{
									tWire.Target.Pin = newName;
								}
							}
						}
					}
				}
			}

			Out_Output();
		}

		public event Action Out_Output;
	}
}
