﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using AB3.DataTypes;

namespace AB3.AppDesigner.Logic
{
	public class EditInterfaceDefinitionValidatorSwitch
	{
		public void In_Input(FDLInterfaceDefinition interfaceDefinition, string newName, Directions direction)
		{
			List<string> tExceptions = new List<string>();
			Out_NameValidation(newName, tExceptions);

			if (tExceptions.Count != 0)
			{
				string tMessage = string.Empty;
				foreach (string tException in tExceptions)
				{
					tMessage += string.Concat(tException, Environment.NewLine);
				}

				MessageBox.Show(tMessage, "Validation error", MessageBoxButton.OK, MessageBoxImage.Error);

				Out_Invalid(interfaceDefinition);
			}
			else
				Out_Valid(interfaceDefinition.Name, newName, direction);
		}

		public event Action<FDLInterfaceDefinition> Out_Invalid;
		public event Action<string, string, Directions> Out_Valid;
		public event Action<string, List<string>> Out_NameValidation;
	}
}
