﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using AB3.AppDesigner.DataTypes;
using AB3.DataTypes;

namespace AB3.AppDesigner.Logic
{
	public class ExistingStepPreparer
	{
		public void In_Input(string stepType, string typeName, double x, double y)
		{
			if (!string.IsNullOrEmpty(FlowDefinitionNameCache.Value))
			{
				if (AppDefinitionCache.Value.FlowDefinitions.ContainsKey(FlowDefinitionNameCache.Value))
				{
					FDLFlowDefinition tFlowDefinition = AppDefinitionCache.Value.FlowDefinitions[FlowDefinitionNameCache.Value];
					FDLStepDefinition tStepDefinition = new FDLStepDefinition();
					tStepDefinition.TypeName = typeName;
					
					// Avoid duplicate name
					if (tFlowDefinition.Steps.Collection.ContainsKey(typeName))
					{
						int i = 0;
						while (tFlowDefinition.Steps.Collection.ContainsKey(string.Concat(typeName, (++i).ToString())))
						{ }
						tStepDefinition.CustomName = string.Concat(typeName, i.ToString());
					}
					else
						tStepDefinition.CustomName = typeName;

					if (stepType == "FlowStep")
						tStepDefinition.IsSubFlowStep = true;

					FDLAttribute tPosition = new FDLAttribute();
					tPosition.Name = "Position";
					int tX = (int)Math.Round(x / 10) * 10;
					int tY = (int)Math.Round(y / 10) * 10;

					tPosition.Value = string.Concat(tX.ToString(), ",", tY.ToString());
					tStepDefinition.Attributes.Add(tPosition.Name, tPosition);

					tFlowDefinition.Steps.Collection.Add(tStepDefinition.CustomName, tStepDefinition);
					Out_Output();
				}
			}
		}

		public event Action Out_Output;
	}
}
