﻿using System;
using AB3.AppDesigner.DataTypes;
using AB3.DataTypes;

namespace AB3.AppDesigner.Logic
{
	public class NewRemarkPreparer
	{
		public void In_Input()
		{
			if (!string.IsNullOrEmpty(FlowDefinitionNameCache.Value))
			{
				if (AppDefinitionCache.Value.FlowDefinitions.ContainsKey(FlowDefinitionNameCache.Value))
				{
					FDLFlowDefinition tFlowDefinition = AppDefinitionCache.Value.FlowDefinitions[FlowDefinitionNameCache.Value];

					// Avoid duplicate name
					string tNewRemarkName = "NewRemark";
					int i = 0;
					while (tFlowDefinition.Remarks.Collection.ContainsKey(string.Concat(tNewRemarkName, (++i).ToString())))
					{ }

					FDLRemarkDefinition tNewRemarkDefinition = new FDLRemarkDefinition();
					tNewRemarkDefinition.Name = string.Concat(tNewRemarkName, i.ToString());
					tFlowDefinition.Remarks.Collection.Add(tNewRemarkDefinition.Name, tNewRemarkDefinition);

					FDLAttribute tCaptionAttribute = new FDLAttribute();
					tCaptionAttribute.Name = "Caption";
					tCaptionAttribute.Value = string.Concat("Caption of remark ", tNewRemarkDefinition.Name);
					tNewRemarkDefinition.Attributes.Add(tCaptionAttribute.Name, tCaptionAttribute);

					Out_Output();
				}
			}
		}

		public event Action Out_Output;
	}
}
