﻿using System;
using System.Collections.Generic;
using AB3.DataTypes;
using AB3.AppDesigner.DataTypes;

namespace AB3.AppDesigner.Logic
{
	public class UsageFinder
	{
		public void In_Input(string partName)
		{
			string tName;

			if (partName.StartsWith("Flow: "))
				tName = partName.Replace("Flow: ", string.Empty);
			else if (partName.StartsWith("Step: "))
				tName = partName.Replace("Step: ", string.Empty);
			else
				throw new ArgumentOutOfRangeException(partName, "Don't know this component '" + partName + "'");

			List<FDLFlowDefinition> tFlowDefinitions = new List<FDLFlowDefinition>();
			foreach (FDLFlowDefinition tFlowDef in AppDefinitionCache.Value.FlowDefinitions.Values)
			{
				foreach (FDLStepDefinition tStepDef in tFlowDef.Steps.Collection.Values)
				{
					if (tStepDef.TypeName == tName)
					{
						tFlowDefinitions.Add(tFlowDef);
						break;
					}
				}
			}

			this.Out_Output(tFlowDefinitions);
		}

		public event Action<IEnumerable<FDLFlowDefinition>> Out_Output;
	}
}
