﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Controls;
using AB3.AppDesigner.DataTypes;
using AB3.DataTypes;

namespace AB3.AppDesigner.Presenters
{
	public class SelectedHierarchyPresenter
	{
		public void In_Input()
		{
			foreach (var tItem in MainWindow.Instance.treeViewHierarchy.Items)
			{
				TreeViewItem tFoundTreeViewItem;

				TreeViewItem tTreeViewItem = (TreeViewItem)tItem;
				FDLStepDefinition tFlowDefinition = (FDLStepDefinition)tTreeViewItem.Tag;
				if (tFlowDefinition.TypeName == FlowDefinitionNameCache.Value)
					tFoundTreeViewItem = tTreeViewItem;
				else
					tFoundTreeViewItem = FindTreeViewItem(tTreeViewItem);

				if (tFoundTreeViewItem != null)
				{
					tFoundTreeViewItem.IsSelected = true;
					break;
				}
			}
		}

		private TreeViewItem FindTreeViewItem(TreeViewItem parentItem)
		{
			foreach (var tItem in parentItem.Items)
			{
				TreeViewItem tTreeViewItem = tItem as TreeViewItem;
				FDLStepDefinition tFlowDefinition = (FDLStepDefinition)tTreeViewItem.Tag;
				if (tFlowDefinition.TypeName == FlowDefinitionNameCache.Value)
				{
					return tTreeViewItem;
				}
				else if (tTreeViewItem.Items.Count != 0)
				{
					TreeViewItem tFoundTreeViewItem = FindTreeViewItem(tTreeViewItem);
					if (tFoundTreeViewItem != null)
						return tFoundTreeViewItem;
				}
			}

			return null;
		}
	}
}
