﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Shapes;
using AB3.AppDesigner.DataTypes;

namespace AB3.AppDesigner.RenderFlow
{
	public class GridRenderer
	{
		public void In_Input()
		{
			if (!MainWindow.Instance.gridChart.CheckAccess())
			{
				MainWindow.Instance.gridChart.Dispatcher.Invoke(new Action(In_Input));
			}
			else
			{
				double tWidth = MainWindow.Instance.gridChart.ActualWidth + 10;
				double tHeight = MainWindow.Instance.gridChart.ActualHeight + 10;
				Line tLine;

				for (int i = 10; i <= tWidth; i += 10)
				{
					tLine = new Line();
					tLine.Stroke = System.Windows.Media.Brushes.Blue;
					tLine.X1 = i;
					tLine.X2 = i;
					tLine.Y1 = 0;
					tLine.Y2 = tHeight;
					tLine.HorizontalAlignment = System.Windows.HorizontalAlignment.Left;
					tLine.VerticalAlignment = System.Windows.VerticalAlignment.Top;
					tLine.StrokeThickness = 1;
					tLine.Opacity = 0.2;

					MainWindow.Instance.gridChart.Children.Insert(0, tLine);
				}

				for (int i = 10; i <= tHeight; i +=10)
				{
					tLine = new Line();
					tLine.Stroke = System.Windows.Media.Brushes.Blue;
					tLine.X1 = 0;
					tLine.X2 = tWidth;
					tLine.Y1 = i;
					tLine.Y2 = i;
					tLine.HorizontalAlignment = System.Windows.HorizontalAlignment.Left;
					tLine.VerticalAlignment = System.Windows.VerticalAlignment.Top;
					tLine.StrokeThickness = 1;
					tLine.Opacity = 0.2;

					MainWindow.Instance.gridChart.Children.Insert(0, tLine);
				}
			}

			Out_Output();
		}

		public event Action Out_Output;
	}
}
