﻿using System;
using System.Collections.Generic;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Media.Effects;
using AB3.AppDesigner.Converters;
using AB3.AppDesigner.DataTypes;
using AB3.AppDesigner.Decorators;
using AB3.AppDesigner.EventHandlers;
using AB3.AppDesigner.Logic;
using AB3.DataTypes;
using AB3.Interfaces;

namespace AB3.AppDesigner.RenderFlow
{
	public class InterfacesRenderer
	{
		public void In_Input()
		{
			if (!MainWindow.Instance.gridChart.CheckAccess())
			{
				MainWindow.Instance.gridChart.Dispatcher.Invoke(new Action(In_Input));
			}
			else
			{
				InterfaceDecorator tInterfaceDecorator;
				foreach (FDLInterfaceDefinition tInterfaceDefinition in AppDefinitionCache.Value.FlowDefinitions[FlowDefinitionNameCache.Value].Interfaces.Collection.Values)
				{
					tInterfaceDecorator = new InterfaceDecorator(tInterfaceDefinition);
					ChartDefinitionCache.Value.InterfaceDecorators.Add(tInterfaceDefinition.Name, tInterfaceDecorator);
					MainWindow.Instance.gridChart.Children.Add(tInterfaceDecorator.View);
					tInterfaceDecorator.Out_ViewDoubleClicked += EditInterfaceDefinitionAdapter.In_Input;
					tInterfaceDecorator.Out_ViewChanged += EditInterfaceViewAdapter.In_Input;
				}
			}

			Out_Output();
		}

		public event Action Out_Output;
	}
}
