﻿using System;
using AB3.AppDesigner.DataTypes;
using AB3.AppDesigner.Decorators;
using AB3.AppDesigner.Logic;
using AB3.DataTypes;

namespace AB3.AppDesigner.RenderFlow
{
	public class RemarksRenderer
	{
		public void In_Input()
		{
			if (!MainWindow.Instance.gridChart.CheckAccess())
			{
				MainWindow.Instance.gridChart.Dispatcher.Invoke(new Action(In_Input));
			}
			else
			{
				FDLFlowDefinition tFlowDefinition = AppDefinitionCache.Value.FlowDefinitions[FlowDefinitionNameCache.Value];
				RemarkDecorator tRemarkDecorator;
				foreach (FDLRemarkDefinition tRemark in tFlowDefinition.Remarks.Collection.Values)
				{
					tRemarkDecorator = new RemarkDecorator(tRemark);
					ChartDefinitionCache.Value.RemarkDecorators.Add(tRemark.Name, tRemarkDecorator);
					MainWindow.Instance.gridChart.Children.Add(tRemarkDecorator.View);
					tRemarkDecorator.Out_ViewDoubleClicked += EditRemarkDefinitionAdapter.In_Input;
					tRemarkDecorator.Out_ViewChanged += EditRemarkViewAdapter.In_Input;
				}
			}

			Out_Output();
		}

		public event Action Out_Output;
	}
}
