﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using AB3.AppDesigner.Converters;
using AB3.AppDesigner.DataTypes;
using AB3.AppDesigner.Decorators;
using AB3.AppDesigner.EventHandlers;
using AB3.AppDesigner.Logic;
using AB3.DataTypes;
using AB3.Helpers;

namespace AB3.AppDesigner.RenderFlow
{
	public class StepsRenderer
	{
		public void In_Input()
		{
			if (!MainWindow.Instance.gridChart.CheckAccess())
			{
				MainWindow.Instance.gridChart.Dispatcher.Invoke(new Action(In_Input));
			}
			else
			{
				StepDecorator tStepDecorator;

				foreach (FDLStepDefinition tStep in AppDefinitionCache.Value.FlowDefinitions[FlowDefinitionNameCache.Value].Steps.Collection.Values)
				{
					tStepDecorator = new StepDecorator(tStep);
					ChartDefinitionCache.Value.StepDecorators.Add(tStep.CustomName, tStepDecorator);
					MainWindow.Instance.gridChart.Children.Add(tStepDecorator.View);
					if (tStep.IsSubFlowStep)
						tStepDecorator.Out_ViewDoubleClicked += EditFlowStepDefinitionAdapter.In_Input;
					else
						tStepDecorator.Out_ViewDoubleClicked += EditSingleStepDefinitionAdapter.In_Input;
					tStepDecorator.Out_ViewChanged += EditStepViewAdapter.In_Input;
				}
			}

			Out_Output();
		}

		public event Action Out_Output;
	}
}
