﻿using System;
using System.Windows;
using AB3.AppDesigner.DataTypes;
using AB3.AppDesigner.Decorators;
using AB3.AppDesigner.Logic;
using AB3.DataTypes;

namespace AB3.AppDesigner.RenderFlow
{
	public class WiresRenderer
	{
		public void In_Input()
		{
			if (!MainWindow.Instance.gridChart.CheckAccess())
			{
				MainWindow.Instance.gridChart.Dispatcher.Invoke(new Action(In_Input));
			}
			else
			{
				int tOrderNumber = 1;
				foreach (FDLWireDefinition tWire in AppDefinitionCache.Value.FlowDefinitions[FlowDefinitionNameCache.Value].Wires.Collection)
				{
					WireDecorator tWireDecorator = new WireDecorator(tWire, tOrderNumber++);
					foreach (var tWirePointDecorator in tWireDecorator.PointDecorators.Values)
					{
						MainWindow.Instance.gridChart.Children.Add(tWirePointDecorator.View);
					}

					foreach (var tWireLineDecorator in tWireDecorator.LineDecorators)
					{
						MainWindow.Instance.gridChart.Children.Add(tWireLineDecorator.View);
					}

					MainWindow.Instance.gridChart.Children.Add(tWireDecorator.ArrowDecorator.View);
					MainWindow.Instance.gridChart.Children.Add(tWireDecorator.CaptionDecorator.View);
					tWireDecorator.CaptionDecorator.RefreshView();

					string tWireKey = tWire.ToString();
					if (!ChartDefinitionCache.Value.WireDecorators.ContainsKey(tWireKey))
						ChartDefinitionCache.Value.WireDecorators.Add(tWireKey, tWireDecorator);

					tWireDecorator.Out_SourceEdgeChanged += EditWireSourceEdgeViewAdapter.In_Input;
					tWireDecorator.Out_TargetEdgeChanged += EditWireTargetEdgeViewAdapter.In_Input;
					tWireDecorator.Out_PointChanged += EditWirePointViewAdapter.In_Input;
				}
			}

			Out_Output();
		}

		public event Action Out_Output;		
	}
}
