﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using AB3.DataTypes;
using AB3.AppDesigner.DataTypes;

namespace AB3.AppDesigner.Validators
{
	public class ValidateIfSubFlowsExist
	{
		public void In_Input()
		{
			string tMessage;
			foreach (FDLFlowDefinition tFlowDefinition in AppDefinitionCache.Value.FlowDefinitions.Values)
			{
				foreach (FDLStepDefinition tStepDefinition in tFlowDefinition.Steps.Collection.Values)
				{
					if (tStepDefinition.IsSubFlowStep)
					{
						if (!AppDefinitionCache.Value.FlowDefinitions.ContainsKey(tStepDefinition.TypeName))
						{
							tMessage = string.Format("Step with type name '{0}' is missing!", tStepDefinition.TypeName);
							FDLException tEx = new FDLException(tMessage,
								tStepDefinition.LineNumber + 1, FileContentCache.Value[tStepDefinition.LineNumber]);
							AppDefinitionCache.Value.ParseExceptions.Add(tEx);
						}
					}
				}
			}

			Out_Output();
		}

		public event Action Out_Output;
	}
}
