﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace AB3.TestWinFormGui
{
    public partial class GuiPart : Form
    {
        public GuiPart()
        {
            InitializeComponent();
        }

        public void In_NewTime(DateTime value)
        {
            if (this.lblClock.InvokeRequired)
            {
                this.lblClock.Invoke(new Action<DateTime>(In_NewTime), value);
            }
            else
            {
                this.lblClock.Text = value.ToLongTimeString();
                this.lblClock.Refresh();
            }
        }        

        private void btSetAlarm_Click(object sender, EventArgs e)
        {
            double tAlarmTime = Convert.ToDouble(this.txtAlarmTime.Text);
            this.Out_SetAlarmTime(tAlarmTime);
        }

        private void btResetAlarm_Click(object sender, EventArgs e)
        {
            this.lblAlarmReached.Text = " . . . ";
            this.Out_ResetAlarmTime();
        }

        public void In_TimeLeft(TimeSpan value)
        {
            if (this.txtTimeLeft.InvokeRequired)
            {
                this.txtTimeLeft.Invoke(new Action<TimeSpan>(In_TimeLeft), value);
            }
            else
            {
                this.txtTimeLeft.Text = value.TotalSeconds.ToString();
            }
        }

        public void In_AlarmTimeReached(DateTime value)
        {
			if (this.txtTimeLeft.InvokeRequired)
            {
				this.txtTimeLeft.Invoke(new Action<DateTime>(In_AlarmTimeReached), value);
            }
            else
            {
                this.txtTimeLeft.Text = string.Empty;
                this.lblAlarmReached.Text = "!!! ALARM !!!";
            }
        }

        public event Action<double> Out_SetAlarmTime;
        public event Action Out_ResetAlarmTime;
    }
}
