﻿using System;

namespace AB3.DataTypes
{
	/// <summary>DataType to store an instance of a step
	/// </summary>
	public class StepInstance
	{
		/// <summary>Returns the full name of the instance: 'MainFlow.SubFlowA.Component1'
		/// </summary>
		/// <returns></returns>
		public string FullName
		{ get { return string.Concat(FDLNamespace, ".", FDLCustomName); } }

		/// <summary>Namespace of the instance (MainFlow.A.B)
		/// </summary>
		public string FDLNamespace { get; private set; }

		/// <summary>Custom name of the instance
		/// </summary>
		public string FDLCustomName { get; set; }

		/// <summary>Instance of the object (or null if static)
		/// </summary>
		public object StepObject { get; set; }

		/// <summary>Type of the instance
		/// </summary>
		public Type StepType { get; set; }

		/// <summary>Creates a new instance item
		/// </summary>
		/// <param name="fdlNamespace">Namespace of the instance (MainFlow.SubFlow1.SubSubFlow1)</param>
		/// <param name="fdlCustomName">Custom name of the instance</param>
		public StepInstance(string fdlNamespace, string fdlCustomName)
		{
			this.FDLNamespace = fdlNamespace;
			this.FDLCustomName = fdlCustomName;
		}		
	}
}
