﻿
namespace AB3.Logging
{
	/// <summary>Category of the message
	/// </summary>
	public enum Category
	{
		/// <summary>The message is an information
		/// </summary>
		Info,

		/// <summary>The massage is a warning
		/// </summary>
		Warning,

		/// <summary>The message is an error
		/// </summary>
		Error
	}

	/// <summary>Interface to implement a generic logger
	/// </summary>
	public interface ILogger
	{
		/// <summary>Logs a message
		/// 
		/// </summary>
		/// <param name="category">The Category of the message</param>
		/// <param name="message">The message to log</param>
		void Log(Category category, string message);

		/// <summary>Logs an information message
		/// </summary>
		/// <param name="message">Template of the message</param>
		/// <param name="args">Values to fill into the placeholders of the message</param>
		void LogInfo(string message, params string[] args);

		/// <summary>Logs a warning message
		/// </summary>
		/// <param name="message">Template of the message</param>
		/// <param name="args">Values to fill into the placeholders of the message</param>
		void LogWarning(string message, params string[] args);

		/// <summary>Logs an error message
		/// </summary>
		/// <param name="message">Template of the message</param>
		/// <param name="args">Values to fill into the placeholders of the message</param>
		void LogError(string message, params string[] args);
	}
}
