﻿using System;

namespace AB3.Patterns
{
	/// <summary>Converts an argument to nothing to be used as trigger
	/// </summary>
	public class ConvertToTrigger<T>
	{
		/// <summary>Emit the trigger
		/// </summary>
		/// <param name="arg">The argument (unused and ignored!)</param>
		public void In_Input(T arg)
		{
			Out_Output();
		}

		/// <summary>Trigger output
		/// </summary>
		public event Action Out_Output;
	}

	/// <summary>Converts two arguments to nothing but a trigger
	/// </summary>
	/// <typeparam name="S">Type of frist argument (ignored)</typeparam>
	/// <typeparam name="T">Type of second argument (ignored)</typeparam>
	public class ConvertToTrigger<S, T>
	{
		/// <summary>Emit the trigger
		/// </summary>
		/// <param name="arg1">The first argument (unused and ignored!)</param>
		/// <param name="arg2">The second argument (unused and ignored!)</param>
		public void In_Input(S arg1, T arg2)
		{
			Out_Output();
		}

		/// <summary>Trigger output
		/// </summary>
		public event Action Out_Output;
	}
}
