﻿using System;

namespace AB3.Patterns
{
	/// <summary>Join to Tuple
	/// </summary>
	/// <typeparam name="TInput1">Type of signal 1</typeparam>
	/// <typeparam name="TInput2">Type of signal 2</typeparam>
	public class JoinToTuple<TInput1, TInput2> : JoinToCustomType<TInput1, TInput2, Tuple<TInput1, TInput2>>
	{ }

	/// <summary>Join to Tuple with auto reset
	/// </summary>
	/// <typeparam name="TInput1">Type of signal 1</typeparam>
	/// <typeparam name="TInput2">Type of signal 2</typeparam>
	public class AutoResetJoinToTuple<TInput1, TInput2> : AutoResetJoinToCustomType<TInput1, TInput2, Tuple<TInput1, TInput2>>
	{ }

	/// <summary>Join to Tuple with manual reset
	/// </summary>
	/// <typeparam name="TInput1">Type of signal 1</typeparam>
	/// <typeparam name="TInput2">Type of signal 2</typeparam>
	public class ManualResetJoinToTuple<TInput1, TInput2> : ManualResetJoinToCustomType<TInput1, TInput2, Tuple<TInput1, TInput2>>
	{ }
}
