﻿using System;
using System.Text;
using System.Collections.Generic;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.Text.RegularExpressions;
using AB3.DataTypes;

namespace AB3.AppBuilderTests
{
	/// <summary>
	/// Summary description for RegexTest1
	/// </summary>
	[TestClass]
	public class RegexTest1
	{
		#region ctor & TestContext
		public RegexTest1()
		{ }

		private TestContext testContextInstance;

		/// <summary>
		///Gets or sets the test context which provides
		///information about and functionality for the current test run.
		///</summary>
		public TestContext TestContext
		{
			get
			{
				return testContextInstance;
			}
			set
			{
				testContextInstance = value;
			}
		}
		#endregion

		#region Additional test attributes
		//
		// You can use the following additional attributes as you write your tests:
		//
		// Use ClassInitialize to run code before running the first test in the class
		// [ClassInitialize()]
		// public static void MyClassInitialize(TestContext testContext) { }
		//
		// Use ClassCleanup to run code after all tests in a class have run
		// [ClassCleanup()]
		// public static void MyClassCleanup() { }
		//
		// Use TestInitialize to run code before running each test 
		// [TestInitialize()]
		// public void MyTestInitialize() { }
		//
		// Use TestCleanup to run code after each test has run
		// [TestCleanup()]
		// public void MyTestCleanup() { }
		//
		#endregion

		[TestMethod]
		public void TestMethod1()
		{
			Dictionary<string, string> hashTable = new Dictionary<string, string>();

			string myString = "Caption = \"The main flow of the application\"Width=\"100\" Height= \"40\" Top = \"100\" Left =\"800\" }";
			//string pattern = @"([A-Za-z0-9]+)(\s*)(=)(\s*)("")([^""]*)("")";
			string pattern = @"(\w+)(\s*)(=)(\s*)("")([^""]*)("")";

			MatchCollection matches = Regex.Matches(myString, pattern);
			foreach (Match m in matches)
			{
				string key = m.Groups[1].Value;    // ([A-Za-z0-9]+)
				string value = m.Groups[6].Value;    // ([^""]*)

				hashTable[key] = value;
			}

			Assert.AreEqual(5, hashTable.Count);
		}
	}
}
