﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using AB3.AppDesigner.DataTypes;
using AB3.DataTypes;

namespace AB3.AppDesigner.Converters
{
	public class AppDefinitionToLinesConverter
	{
		public void In_Input()
		{
			List<string> tLines = new List<string>();
			string tLine;

			foreach (FDLFlowDefinition tFlowDefinition in AppDefinitionCache.Value.FlowDefinitions.Values)
			{
				tLines.Add(string.Concat("FlowDefinition: ", tFlowDefinition.Name, " {"));

				#region Remarks
				foreach (FDLRemarkDefinition tRemarkDefinition in tFlowDefinition.Remarks.Collection.Values)
				{
					if (tRemarkDefinition.Attributes.Count == 0)
						tLines.Add(string.Concat("\tRemark: ", tRemarkDefinition.Name));
					else
					{
						tLines.Add(string.Concat("\tRemark: ", tRemarkDefinition.Name, " {"));
						tLines.Add(string.Concat("\t\t", FDLAttributeConverter.ToString(tRemarkDefinition.Attributes.Values), "}"));
					}
				}
				#endregion

				#region Steps / Flows
				foreach (FDLStepDefinition tStepDefinition in tFlowDefinition.Steps.Collection.Values)
				{
					if (tStepDefinition.IsSubFlowStep)
						tLine = "\tFlow: " + tStepDefinition.TypeName;
					else
						tLine = "\tStep: " + tStepDefinition.TypeName;

					if (tStepDefinition.CustomName != tStepDefinition.TypeName)
						tLine += " => " + tStepDefinition.CustomName;

					if (tStepDefinition.Attributes.Count == 0)
						tLines.Add(tLine);
					else
					{
						tLines.Add(tLine + " {");
						tLines.Add(string.Concat("\t\t", FDLAttributeConverter.ToString(tStepDefinition.Attributes.Values), "}"));
					}
				}
				#endregion

				#region Interfaces
				foreach (FDLInterfaceDefinition tInterfaceDefinition in tFlowDefinition.Interfaces.Collection.Values)
				{
					if (tInterfaceDefinition.Direction == Directions.In)
						tLine = "\tIn: " + tInterfaceDefinition.Name;
					else
						tLine = "\tOut: " + tInterfaceDefinition.Name;

					if (tInterfaceDefinition.Attributes.Count == 0)
						tLines.Add(tLine);
					else
					{
						tLines.Add(tLine + " {");
						tLines.Add(string.Concat("\t\t", FDLAttributeConverter.ToString(tInterfaceDefinition.Attributes.Values), "}"));
					}
				}
				#endregion

				#region Wires
				foreach (FDLWireDefinition tWireDefinition in tFlowDefinition.Wires.Collection)
				{
					if (tWireDefinition.Attributes.Count == 0)
					{
						tLines.Add(string.Concat("\tWire: ",
							tWireDefinition.Source.ToString(),
							" -> ",
							tWireDefinition.Target.ToString()));
					}
					else
					{
						tLines.Add(string.Concat("\tWire: ",
							tWireDefinition.Source.ToString(),
							" -> ",
							tWireDefinition.Target.ToString(),
							" {"));
						tLines.Add(string.Concat("\t\t", FDLAttributeConverter.ToString(tWireDefinition.Attributes.Values), " }"));
					}
				}
				#endregion

				tLines.Add("}"); // End of FlowDefinition
				tLines.Add(string.Empty);
			}

			FileContentCache.Value = tLines;
			Out_Output();
		}

		public event Action Out_Output;
	}
}
