﻿using System;
using System.Collections.Generic;
using System.Windows.Controls;
using AB3.AppDesigner.Helpers;
using AB3.DataTypes;

namespace AB3.AppDesigner.Converters
{
	public class BorderToAttributesConverter
	{
		public void In_Input(Border border, Dictionary<string, FDLAttribute> attributes)
		{
			FDLAttribute tSizeAttribute = ChartHelper.GetSizeAttribute(border);
			if (attributes.ContainsKey(tSizeAttribute.Name))
				attributes[tSizeAttribute.Name] = tSizeAttribute;
			else
				attributes.Add(tSizeAttribute.Name, tSizeAttribute);

			FDLAttribute tPositionAttribute = ChartHelper.GetPositionAttribute(border);
			if (attributes.ContainsKey(tPositionAttribute.Name))
				attributes[tPositionAttribute.Name] = tPositionAttribute;
			else
				attributes.Add(tPositionAttribute.Name, tPositionAttribute);

			Out_Output();
		}

		public event Action Out_Output;
	}
}
