﻿using System.Collections.Generic;
using System.Windows.Controls;
using System.Windows.Shapes;
using AB3.AppDesigner.Decorators;

namespace AB3.AppDesigner.DataTypes
{
	public class ChartDefinition
	{
		/// <summary>The remarks of flow definition
		/// </summary>
		public Dictionary<string, RemarkDecorator> RemarkDecorators { get; set; }

		/// <summary>The interfaces of the flow definition
		/// </summary>
		public Dictionary<string, InterfaceDecorator> InterfaceDecorators { get; set; }

		/// <summary>The steps of the flow definition
		/// </summary>
		public Dictionary<string, StepDecorator> StepDecorators { get; set; }

		/// <summary>The wires of the flow definition
		/// </summary>
		public Dictionary<string, WireDecorator> WireDecorators { get; set; }

		public ChartDefinition()
		{
			RemarkDecorators = new Dictionary<string, RemarkDecorator>();
			InterfaceDecorators = new Dictionary<string, InterfaceDecorator>();
			StepDecorators = new Dictionary<string, StepDecorator>();
			WireDecorators = new Dictionary<string, WireDecorator>();
		}
	}
}
