﻿using System.Collections.Generic;

namespace AB3.AppDesigner.DataTypes
{
	public class EditWireArgumentConnections
	{
		/// <summary>Simple list of possible interfaces (In or Out) 
		/// </summary>
		public List<string> Interfaces { get; private set; }

		/// <summary>List of FlowSteps: Key = FlowName, Values are the interfaces of the flow
		/// </summary>
		public Dictionary<string, List<string>> FlowSteps { get; private set; }

		/// <summary>List of SingleSteps: Key = StepName, Values are used pins of step
		/// </summary>
		public Dictionary<string, List<string>> SingleSteps { get; private set; }

		public EditWireArgumentConnections()
		{
			this.Interfaces = new List<string>();
			this.FlowSteps = new Dictionary<string, List<string>>();
			this.SingleSteps = new Dictionary<string, List<string>>();
		}
	}
}
