﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Xml;
using AB3.Interfaces;
using ICSharpCode.AvalonEdit.Highlighting;
using ICSharpCode.AvalonEdit.Highlighting.Xshd;

namespace AB3.AppDesigner.EventHandlers
{
	public class FileEventHandler: IInitialize
	{
		#region IInitialize
		public void Initialize(object args)
		{
			MainWindow.Instance.textEditor.TextChanged += textEditor_TextChanged;

			ASCIIEncoding tEncoder = new ASCIIEncoding();
			byte[] tBytes = tEncoder.GetBytes(AB3.AppDesigner.Properties.Resources.AB3_xshd);

			using (Stream tStream = new MemoryStream(tBytes))
			{
				using (XmlReader tReader = new XmlTextReader(tStream))
				{
					IHighlightingDefinition tAppDesignerHighlighing = HighlightingLoader.Load(tReader, HighlightingManager.Instance);
					MainWindow.Instance.textEditor.SyntaxHighlighting = tAppDesignerHighlighing;
				}
			}
		}
		#endregion

		private void textEditor_TextChanged(object sender, EventArgs e)
		{
			//if (!FilePresenter.InInitialization)
			{
				this.Out_Output(MainWindow.Instance.textEditor.Text);
			}
		}

		public event Action<string> Out_Output;
	}
}
