﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Controls;
using AB3.AppDesigner.DataTypes;
using AB3.DataTypes;
using AB3.Interfaces;

namespace AB3.AppDesigner.EventHandlers
{
	public class HierarchyEventHandler: IInitialize
	{
		public void Initialize(object args)
		{
			MainWindow.Instance.treeViewHierarchy.MouseDoubleClick += treeViewHierarchy_MouseDoubleClick;
		}

		private void treeViewHierarchy_MouseDoubleClick(object sender, System.Windows.Input.MouseButtonEventArgs e)
		{
			if (MainWindow.Instance.treeViewHierarchy.SelectedItem != null)
			{
				TreeViewItem tSelectedTreeViewItem = MainWindow.Instance.treeViewHierarchy.SelectedItem as TreeViewItem;
				if (tSelectedTreeViewItem != null)
				{
					FDLStepDefinition tStepDef = (FDLStepDefinition)tSelectedTreeViewItem.Tag;
					if (AppDefinitionCache.Value.FlowDefinitions.ContainsKey(tStepDef.TypeName))
						FlowDefinitionNameCache.Value = tStepDef.TypeName;
					else
						FlowDefinitionNameCache.Value = string.Empty;

					Out_Output();
				}
			}
		}

		public event Action Out_Output;
	}
}
