﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using AB3.AppDesigner.DataTypes;
using AB3.DataTypes;

namespace AB3.AppDesigner.Logic
{
	public class ChangeAllFlowDefinitions
	{
		public void In_Input(FDLFlowDefinition flowDefinition, string newName)
		{
			StepChangeArgument tStepChangeArgument = new StepChangeArgument();
			tStepChangeArgument.OldCustomName = flowDefinition.Name;
			tStepChangeArgument.OldTypeName = flowDefinition.Name;
			
			// First rename the flow definition itself
			if (newName != flowDefinition.Name)
			{
				AppDefinitionCache.Value.FlowDefinitions.Remove(flowDefinition.Name);
				flowDefinition.Name = newName;
				AppDefinitionCache.Value.FlowDefinitions.Add(flowDefinition.Name, flowDefinition);
				FlowDefinitionNameCache.Value = flowDefinition.Name;
				tStepChangeArgument.NewCustomName = newName;
				tStepChangeArgument.NewTypeName = newName;
			}


			// Second rename SubFlowSteps of all other flow definitions
			foreach (FDLFlowDefinition tFlowDefinition in AppDefinitionCache.Value.FlowDefinitions.Values)
			{
				List<FDLStepDefinition> tStepDefinitionsToChange = new List<FDLStepDefinition>();

				foreach (FDLStepDefinition tStepDefinition in tFlowDefinition.Steps.Collection.Values)
				{
					if ((tStepDefinition.IsSubFlowStep) && (tStepDefinition.TypeName == tStepChangeArgument.OldTypeName))
						tStepDefinitionsToChange.Add(tStepDefinition);
				}

				foreach (FDLStepDefinition tStepDefinitionToChange in tStepDefinitionsToChange)
				{
					tFlowDefinition.Steps.Collection.Remove(tStepDefinitionToChange.CustomName);

					if (tStepDefinitionToChange.TypeName == tStepDefinitionToChange.CustomName)
					{
						tStepDefinitionToChange.TypeName = newName;
						tStepDefinitionToChange.CustomName = newName;
					}
					else
						tStepDefinitionToChange.TypeName = newName;

					tFlowDefinition.Steps.Collection.Add(tStepDefinitionToChange.CustomName, tStepDefinitionToChange);
				}
			}
			
			Out_Output(tStepChangeArgument);
		}

		public event Action<StepChangeArgument> Out_Output;
	}
}
