﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using AB3.AppDesigner.DataTypes;
using AB3.DataTypes;

namespace AB3.AppDesigner.Logic
{
	public class ChangeAllSingleStepDefinitions
	{
		public void In_Input(FDLStepDefinition stepDefinition, string newTypeName, string newCustomName)
		{
			StepChangeArgument tStepChangeArgument = new StepChangeArgument();
			tStepChangeArgument.OldCustomName = stepDefinition.CustomName;
			tStepChangeArgument.OldTypeName = stepDefinition.TypeName;

			// First change the source step because of the custom name.
			{
				FDLFlowDefinition tFlowDefinition = AppDefinitionCache.Value.FlowDefinitions[FlowDefinitionNameCache.Value];
				tFlowDefinition.Steps.Collection.Remove(stepDefinition.CustomName);
				stepDefinition.TypeName = newTypeName;
				if (string.IsNullOrEmpty(newCustomName))
					stepDefinition.CustomName = stepDefinition.TypeName;
				else
					stepDefinition.CustomName = newCustomName;

				tStepChangeArgument.NewCustomName = stepDefinition.CustomName;
				tStepChangeArgument.NewTypeName = stepDefinition.TypeName;
				tFlowDefinition.Steps.Collection.Add(stepDefinition.CustomName, stepDefinition);
			}

			// Second change all other steps (custom name will be ignored!)
			{
				foreach (FDLFlowDefinition tFlowDefinition in AppDefinitionCache.Value.FlowDefinitions.Values)
				{
					List<FDLStepDefinition> tStepDefinitionsToChange = new List<FDLStepDefinition>();

					foreach (FDLStepDefinition tStepDefinition in tFlowDefinition.Steps.Collection.Values)
					{
						if (tStepDefinition.TypeName == tStepChangeArgument.OldTypeName)
							tStepDefinitionsToChange.Add(tStepDefinition);
					}

					foreach (FDLStepDefinition tStepDefinitionToChange in tStepDefinitionsToChange)
					{
						tFlowDefinition.Steps.Collection.Remove(tStepDefinitionToChange.CustomName);

						if (tStepDefinitionToChange.TypeName == tStepDefinitionToChange.CustomName)
						{
							tStepDefinitionToChange.TypeName = newTypeName;
							tStepDefinitionToChange.CustomName = newTypeName;
						}
						else
							tStepDefinitionToChange.TypeName = newTypeName;

						tFlowDefinition.Steps.Collection.Add(tStepDefinitionToChange.CustomName, tStepDefinitionToChange);
					}
				}
			}

			Out_Output(tStepChangeArgument);
		}

		public event Action<StepChangeArgument> Out_Output;
	}
}
