﻿using System;
using AB3.AppDesigner.DataTypes;
using AB3.DataTypes;

namespace AB3.AppDesigner.Logic
{
	public class ChangeStepWiresOfRelatedFlowDefinitions
	{
		public void In_Input(StepChangeArgument arg)
		{
			foreach (FDLFlowDefinition tFlowDefinition in AppDefinitionCache.Value.FlowDefinitions.Values)
			{
				// Only related flows
				if (tFlowDefinition.Name != FlowDefinitionNameCache.Value)
				{
					foreach (FDLStepDefinition tStepDefinition in tFlowDefinition.Steps.Collection.Values)
					{
						// Does the flow using the changed step & using NO custom name?
						if ((tStepDefinition.TypeName == arg.NewTypeName) && (tStepDefinition.TypeName == tStepDefinition.CustomName))
						{
							foreach (FDLWireDefinition tWire in tFlowDefinition.Wires.Collection)
							{
								// Is this the wireDefinition using the changed step definition?
								if (tWire.Source.Step == arg.OldTypeName)
									tWire.Source.Step = arg.NewTypeName;
								else if (tWire.Target.Step == arg.OldTypeName)
									tWire.Target.Step = arg.NewTypeName;
							}
						}						
					}
				}
			}

			Out_Output();
		}

		public event Action Out_Output;
	}
}
