﻿using System;
using System.Windows;
using AB3.AppDesigner.DataTypes;
using AB3.AppDesigner.EditWindows;
using AB3.DataTypes;

namespace AB3.AppDesigner.Logic
{
	public class EditInterfaceDefinition
	{
		public void In_Input(FDLInterfaceDefinition interfaceDefinition)
		{
			EditInterfaceWindow tWindow = new EditInterfaceWindow();
			tWindow.textBoxName.Text = interfaceDefinition.Name;
			switch (interfaceDefinition.Direction)
			{
				case Directions.In:
					tWindow.radioButtonIn.IsChecked = true;
					break;
				case Directions.Out:
					tWindow.radioButtonOut.IsChecked = true;
					break;
				default:
					throw new ArgumentOutOfRangeException("interfaceDefinition", "AB3.AppDesigner.Logic.EditInterfaceDefinition.In_Input: This value is not possible!");
			}

			tWindow.Owner = MainWindow.Instance;
			tWindow.WindowStartupLocation = WindowStartupLocation.CenterOwner;
			bool? tResponse = tWindow.ShowDialog();

			if ((tResponse.HasValue) && (tResponse.Value == true))
			{
				Directions tDirection;
				if ((tWindow.radioButtonIn.IsChecked.HasValue) && (tWindow.radioButtonIn.IsChecked.Value))
					tDirection = Directions.In;
				else if ((tWindow.radioButtonOut.IsChecked.HasValue) && (tWindow.radioButtonOut.IsChecked.Value))
					tDirection = Directions.Out;
				else
					throw new ArgumentOutOfRangeException("Direction", "AB3.AppDesigner.Logic.EditInterfaceDefinition.In_Input: This value is not possible!");

				Out_Output(interfaceDefinition, tWindow.textBoxName.Text, tDirection);
			}			
		}

		public event Action<FDLInterfaceDefinition, string, Directions> Out_Output;
	}
}
