﻿using System;
using System.Collections.Generic;
using System.Windows;
using AB3.DataTypes;

namespace AB3.AppDesigner.Logic
{
	public class EditRemarkDefinitionValidatorSwitch
	{
		public void In_Input(FDLRemarkDefinition remarkDefinition, string newName, string newCaption)
		{
			List<string> tExceptions = new List<string>();
			if (remarkDefinition.Name != newName) // 55.01 (Bugfix): Only validate if name was changed
				Out_NameValidation(newName, tExceptions);
			Out_CaptionValidation(newCaption, tExceptions);

			if (tExceptions.Count != 0)
			{
				string tMessage = string.Empty;
				foreach (string tException in tExceptions)
				{
					tMessage += string.Concat(tException, Environment.NewLine);
				}

				MessageBox.Show(tMessage, "Validation error", MessageBoxButton.OK, MessageBoxImage.Error);

				Out_Invalid(remarkDefinition);
			}
			else
				Out_Valid(remarkDefinition, newName, newCaption);
		}

		public event Action<FDLRemarkDefinition> Out_Invalid;
		public event Action<FDLRemarkDefinition, string, string> Out_Valid;
		public event Action<string, List<string>> Out_NameValidation;
		public event Action<string, List<string>> Out_CaptionValidation;
	}
}
