﻿using System;
using System.Collections.Generic;
using System.Windows;
using AB3.DataTypes;

namespace AB3.AppDesigner.Logic
{
	public class EditStepDefinitionValidatorSwitch
	{
		public void In_Input(FDLStepDefinition stepDefinition, string newTypeName, string newCustomName)
		{
			List<string> tExceptions = new List<string>();
			Out_TypeNameValidation(newTypeName, tExceptions);
			if (string.IsNullOrEmpty(newCustomName))
				Out_CustomNameValidation(newTypeName, tExceptions);
			else
				Out_CustomNameValidation(newCustomName, tExceptions);

			if (tExceptions.Count != 0)
			{
				string tMessage = string.Empty;
				foreach (string tException in tExceptions)
				{
					tMessage += string.Concat(tException, Environment.NewLine);
				}

				MessageBox.Show(tMessage, "Validation error", MessageBoxButton.OK, MessageBoxImage.Error);

				Out_Invalid(stepDefinition);
			}
			else
				Out_Valid(stepDefinition, newTypeName, newCustomName);
		}

		public event Action<FDLStepDefinition> Out_Invalid;
		public event Action<FDLStepDefinition, string, string> Out_Valid;
		public event Action<string, List<string>> Out_TypeNameValidation;
		public event Action<string, List<string>> Out_CustomNameValidation;
	}
}
