﻿using System;
using System.Linq;
using System.Windows;
using AB3.AppDesigner.DataTypes;
using AB3.AppDesigner.EditWindows;
using AB3.DataTypes;

namespace AB3.AppDesigner.Logic
{
	public class EditWireDefinition
	{
		private EditWireWindow _EditWindow;

		public void In_Input(FDLWireDefinition wireDefinition, EditWireArgument argument)
		{
			if (!AppDefinitionCache.Value.FlowDefinitions.ContainsKey(FlowDefinitionNameCache.Value))
				return;

			_EditWindow = new EditWireWindow(wireDefinition.Source, wireDefinition.Target, argument);

			if (wireDefinition.Attributes.ContainsKey("Caption"))
				_EditWindow.textBoxCaption.Text = wireDefinition.Attributes["Caption"].Value;
			else
				_EditWindow.textBoxCaption.Text = string.Empty;
			
			_EditWindow.Owner = MainWindow.Instance;
			_EditWindow.WindowStartupLocation = System.Windows.WindowStartupLocation.CenterOwner;

			#region ShowDialog-Part
			bool? tResponse = _EditWindow.ShowDialog();
			if ((tResponse.HasValue) && (tResponse.Value == true)) // OK Button
			{
				#region Caption-Part
				if (string.IsNullOrEmpty(_EditWindow.textBoxCaption.Text))
				{
					if (wireDefinition.Attributes.ContainsKey("Caption"))
						wireDefinition.Attributes.Remove("Caption");
				}
				else
				{
					FDLAttribute tCaptionAttribute;
					if (wireDefinition.Attributes.ContainsKey("Caption"))
						tCaptionAttribute = wireDefinition.Attributes["Caption"];
					else
					{
						tCaptionAttribute = new FDLAttribute();
						tCaptionAttribute.Name = "Caption";
						wireDefinition.Attributes.Add(tCaptionAttribute.Name, tCaptionAttribute);
					}

					tCaptionAttribute.Value = _EditWindow.textBoxCaption.Text;
				}
				#endregion

				#region Connection-Part
				if (_EditWindow.textBoxDefinition.Text != wireDefinition.ToString()) // There was something entered in the textbox => Parse text
				{
					wireDefinition.Source.Step = _EditWindow.WireSource.Step;
					wireDefinition.Source.Pin = _EditWindow.WireSource.Pin;
					wireDefinition.Target.Step = _EditWindow.WireTarget.Step;
					wireDefinition.Target.Pin = _EditWindow.WireTarget.Pin;
				}
				#endregion

				Out_Output(wireDefinition);
			}

			_EditWindow = null;
			#endregion
		}
						
		public event Action<FDLWireDefinition> Out_Output;		
	}
}
