﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using AB3.DataTypes;

namespace AB3.AppDesigner.Logic
{
	public class InsertPointAttributeToAppDefinition
	{
		public void In_Input(FDLWireDefinition wireDefinition, FDLAttribute pointAttribute)
		{
			int tPointNumber = Convert.ToInt32(pointAttribute.Name.Replace("Point", string.Empty));
			int tPointCount = 0;

			foreach (string tKey in wireDefinition.Attributes.Keys)
			{
				if (tKey.StartsWith("Point"))
					tPointCount++;
			}

			for (int i = tPointCount; i >= tPointNumber; i--)
			{
				string tOldName = string.Concat("Point", i);
				string tNewName = string.Concat("Point", (i + 1));

				FDLAttribute tAttribute = wireDefinition.Attributes[tOldName];
				wireDefinition.Attributes.Remove(tOldName);
				tAttribute.Name = tNewName;
				wireDefinition.Attributes.Add(tAttribute.Name, tAttribute);
			}

			wireDefinition.Attributes.Add(pointAttribute.Name, pointAttribute);

			Out_Output();
		}

		public event Action Out_Output;
	}
}
