﻿using System;
using AB3.AppDesigner.DataTypes;
using AB3.DataTypes;

namespace AB3.AppDesigner.Logic
{
	public class NewInterfacePreparer
	{
		public void In_Input(Directions direction)
		{
			if (!string.IsNullOrEmpty(FlowDefinitionNameCache.Value))
			{
				if (AppDefinitionCache.Value.FlowDefinitions.ContainsKey(FlowDefinitionNameCache.Value))
				{
					FDLFlowDefinition tFlowDefinition = AppDefinitionCache.Value.FlowDefinitions[FlowDefinitionNameCache.Value];

					// Avoid duplicate name
					string tNewInterfaceName;
					switch (direction)
					{
						case Directions.In:
							tNewInterfaceName = "NewIn";
							break;
						case Directions.Out:
							tNewInterfaceName = "NewOut";
							break;
						default:
							throw new ArgumentOutOfRangeException("direction", "AB3.AppDesigner.Logic.NewInterfacePreparer.In_Input: This interface direction is not possible!");
					}
					
					int i = 0;
					while (tFlowDefinition.Interfaces.Collection.ContainsKey(string.Concat(tNewInterfaceName, (++i).ToString())))
					{ }

					FDLInterfaceDefinition tNewInterfaceDefinition = new FDLInterfaceDefinition();
					tNewInterfaceDefinition.Name = string.Concat(tNewInterfaceName, i.ToString());
					tNewInterfaceDefinition.Direction = direction;
					tFlowDefinition.Interfaces.Collection.Add(tNewInterfaceDefinition.Name, tNewInterfaceDefinition);

					Out_Output();
				}
			}
		}

		public event Action Out_Output;
	}
}
