﻿using System;
using System.Windows;
using AB3.DataTypes;

namespace AB3.AppDesigner.Logic
{
	public class NewPointAttributePreparer
	{
		public void In_Input(FDLWireDefinition wireDefinition, string addBeforePointName, Point point)
		{
			FDLAttribute tPointAttribute = new FDLAttribute();
			tPointAttribute.Value = string.Concat(point.X, ",", point.Y);

			if (string.IsNullOrEmpty(addBeforePointName))
				Out_Append(wireDefinition, tPointAttribute);
			else
			{
				tPointAttribute.Name = addBeforePointName;
				Out_Insert(wireDefinition, tPointAttribute);
			}
		}

		public event Action<FDLWireDefinition, FDLAttribute> Out_Append;
		public event Action<FDLWireDefinition, FDLAttribute> Out_Insert;
	}
}
