﻿using System;
using AB3.DataTypes;

namespace AB3.AppDesigner.Logic
{
	public class RemovePointAttributeFromWireDefinition
	{
		public void In_Input(FDLWireDefinition wireDefinition, string pointName)
		{
			if (wireDefinition.Attributes.ContainsKey(pointName))
			{
				int tPointNumber = Convert.ToInt32(pointName.Replace("Point", string.Empty));
				int tPointCount = 0;

				foreach (string tKey in wireDefinition.Attributes.Keys)
				{
					if (tKey.StartsWith("Point"))
						tPointCount++;
				}

				wireDefinition.Attributes.Remove(pointName);
				for (int i = (tPointNumber +1); i <= tPointCount; i++)
				{
					string tOldName = string.Concat("Point", i);
					string tNewName = string.Concat("Point", (i - 1));

					FDLAttribute tAttribute = wireDefinition.Attributes[tOldName];
					wireDefinition.Attributes.Remove(tOldName);
					tAttribute.Name = tNewName;
					wireDefinition.Attributes.Add(tAttribute.Name, tAttribute);
				}

				Out_Output();
			}
		}

		public event Action Out_Output;
	}
}
