﻿using System.IO;
using System.Reflection;
using System.Windows;
using AB3;
using AB3.AppDesigner.DataTypes;
using AB3.AppDesigner.Logic;

namespace AB3.AppDesigner
{
	/// <summary>Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		public static MainWindow Instance { get; private set; }

		public MainWindow()
		{
			InitializeComponent();
			Instance = this;
		}

		private void MainWindow_Loaded(object sender, RoutedEventArgs e)
		{
			//AppBuilder tAppBuilder = new AppBuilder();
			AppBuilder tAppBuilder = new AppBuilder("AB3.AppDesigner.log", 1);
			tAppBuilder.LoadFlowsFromString(AB3.AppDesigner.Properties.Resources.AB3_AppDesigner);

			AppConfig tAppConfig = (new AppConfigHandler()).GetAppConfig();

			tAppBuilder.BuildApp(tAppConfig, null);
		}
	}
}
