﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using AB3.AppDesigner.DataTypes;
using AB3.DataTypes;

namespace AB3.AppDesigner.Presenters
{
	public class HierarchyPresenter
	{
		private object _DummyNode = null;

		public void In_Input()
		{
			if (MainWindow.Instance.treeViewHierarchy.CheckAccess())
			{
				MainWindow.Instance.treeViewHierarchy.Items.Clear();

				if (AppDefinitionCache.Value.FlowDefinitions.Count == 0)
					return;
				if (!AppDefinitionCache.Value.FlowDefinitions.ContainsKey("MainFlow"))
					return;

				FDLFlowDefinition tMainFlow = AppDefinitionCache.Value.FlowDefinitions["MainFlow"];
				FDLStepDefinition tMainStep = new FDLStepDefinition();
				tMainStep.TypeName = tMainFlow.Name;
				tMainStep.IsSubFlowStep = true;

				TreeViewItem tMainFlowItem = new TreeViewItem();
				tMainFlowItem.Header = tMainFlow.Name;
				tMainFlowItem.Tag = tMainStep;
				tMainFlowItem.FontWeight = FontWeights.Heavy;
				tMainFlowItem.Items.Add(this._DummyNode);
				MainWindow.Instance.treeViewHierarchy.Items.Add(tMainFlowItem);
				tMainFlowItem.Expanded += new RoutedEventHandler(treeViewItem_Expanded);
				tMainFlowItem.Collapsed += treeViewItem_Collapsed;
				tMainFlowItem.IsExpanded = true;
			}
			else
				MainWindow.Instance.listViewParts.Dispatcher.Invoke(new Action(In_Input));
		}

		private void treeViewItem_Collapsed(object sender, RoutedEventArgs e)
		{
			TreeViewItem tTreeViewItem = (TreeViewItem)sender;
			tTreeViewItem.IsExpanded = true;
			e.Handled = true;
		}

		private void treeViewItem_Expanded(object sender, RoutedEventArgs e)
		{
			TreeViewItem tCurrentItem = (TreeViewItem)sender;
			if ((tCurrentItem.Items.Count == 1) && (tCurrentItem.Items[0] == this._DummyNode))
			{
				tCurrentItem.Items.Clear();
				FDLStepDefinition tCurrentStep = (FDLStepDefinition)tCurrentItem.Tag;
				if (tCurrentStep.IsSubFlowStep)
				{
					if (AppDefinitionCache.Value.FlowDefinitions.ContainsKey(tCurrentStep.TypeName))
					{
						FDLFlowDefinition tCurrentFlow = AppDefinitionCache.Value.FlowDefinitions[tCurrentStep.TypeName];
						foreach (FDLStepDefinition tStepDefinition in tCurrentFlow.Steps.Collection.Values)
						{
							if (tStepDefinition.IsSubFlowStep)
							{
								TreeViewItem tNewItem = new TreeViewItem();
								string tHeaderString;
								if (tStepDefinition.CustomName != tStepDefinition.TypeName)
									tHeaderString = tStepDefinition.TypeName + " (" + tStepDefinition.CustomName + ")";
								else
									tHeaderString = tStepDefinition.TypeName;
								tNewItem.Header = tHeaderString;
								tNewItem.Tag = tStepDefinition;
								tNewItem.FontWeight = FontWeights.Normal;
								tNewItem.Items.Add(this._DummyNode);
								tCurrentItem.Items.Add(tNewItem);
								tNewItem.Expanded += new RoutedEventHandler(treeViewItem_Expanded);
								tNewItem.Collapsed += treeViewItem_Collapsed;
								tNewItem.IsExpanded = true;
							}
						}
					}
				}
			}
		}
	}
}
