﻿using System;
using System.Collections.Generic;
using AB3.DataTypes;
using AB3.AppDesigner.DataTypes;

namespace AB3.AppDesigner.Validators
{
	public class ValidateIfAnyStepsInFlow
	{
		public void In_Input()
		{
			foreach (FDLFlowDefinition tFlowDefinition in AppDefinitionCache.Value.FlowDefinitions.Values)
			{
				if (tFlowDefinition.Steps.Collection.Count == 0)
				{
					FDLException tEx = new FDLException("Steps are missing!",
						tFlowDefinition.Range.StartLine + 1,
						FileContentCache.Value[tFlowDefinition.Range.StartLine]);
					AppDefinitionCache.Value.ParseExceptions.Add(tEx);
				}
				else
				{
					foreach (FDLStepDefinition tStep in tFlowDefinition.Steps.Collection.Values)
					{
						if (tStep.CustomName.Contains(" "))
						{
							FDLException tEx = new FDLException("Step with space in custom name found!",
							tStep.LineNumber + 1, FileContentCache.Value[tStep.LineNumber]);
							AppDefinitionCache.Value.ParseExceptions.Add(tEx);
						}
						else if (tStep.TypeName.Contains(" "))
						{
							FDLException tEx = new FDLException("Step with space in type name found!",
							tStep.LineNumber + 1, FileContentCache.Value[tStep.LineNumber]);
							AppDefinitionCache.Value.ParseExceptions.Add(tEx);
						}
					}
				}
			}

			Out_Output();
		}

		public event Action Out_Output;
	}
}
