﻿using System;
using System.Collections.Generic;
using AB3.AppDesigner.DataTypes;
using AB3.DataTypes;

namespace AB3.AppDesigner.Validators
{
	public class ValidateIfWiresAreComplete
	{
		public void In_Input()
		{
			Dictionary<string, FDLWireDefinition> tWireDefinitions;
			foreach (FDLFlowDefinition tFlowDefinition in AppDefinitionCache.Value.FlowDefinitions.Values)
			{
				tWireDefinitions = new Dictionary<string, FDLWireDefinition>();
				foreach (FDLWireDefinition tWireDefinition in tFlowDefinition.Wires.Collection)
				{
					if (string.IsNullOrEmpty(tWireDefinition.Source.Step))
						AddWireIncompleteException("Imcomplete wireDefinition detected (Source Step is missing)", tWireDefinition);

					if (string.IsNullOrEmpty(tWireDefinition.Source.Pin))
						AddWireIncompleteException("Imcomplete wireDefinition detected (Source Pin is missing)", tWireDefinition);

					if (string.IsNullOrEmpty(tWireDefinition.Target.Step))
						AddWireIncompleteException("Imcomplete wireDefinition detected (Target Step is missing)", tWireDefinition);

					if (string.IsNullOrEmpty(tWireDefinition.Target.Pin))
						AddWireIncompleteException("Imcomplete wireDefinition detected (Target Pin is missing)", tWireDefinition);
				}
			}

			this.Out_Output();
		}

		private void AddWireIncompleteException(string message, FDLWireDefinition wireDefinition)
		{
			FDLException tEx = new FDLException(message, wireDefinition.LineNumber + 1, FileContentCache.Value[wireDefinition.LineNumber]);
			AppDefinitionCache.Value.ParseExceptions.Add(tEx);
		}

		public event Action Out_Output;
	}
}
