﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using AB3.DataTypes;
using AB3.AppDesigner.DataTypes;

namespace AB3.AppDesigner.Validators
{
	public class ValidateInterfaces
	{
		public void In_Input()
		{
			foreach (FDLFlowDefinition tFlowDefinition in AppDefinitionCache.Value.FlowDefinitions.Values)
			{
				foreach (FDLInterfaceDefinition tInterfaceDefinition in tFlowDefinition.Interfaces.Collection.Values)
				{
					if (tInterfaceDefinition.Name.Contains(" "))
					{
						FDLException tEx = new FDLException("Interface with space found!",
							tInterfaceDefinition.LineNumber + 1, FileContentCache.Value[tInterfaceDefinition.LineNumber]);
						AppDefinitionCache.Value.ParseExceptions.Add(tEx);
					}

					FDLWireDefinition tConnectionFound = null;
					if (tInterfaceDefinition.Direction == Directions.In)
					{
						foreach (FDLWireDefinition tConnection in tFlowDefinition.Wires.Collection)
						{
							if ((tConnection.Source.Step == "In")
								&& (tConnection.Source.Pin == tInterfaceDefinition.Name))
							{
								tConnectionFound = tConnection;
								break;
							}
						}
					}
					else
					{
						foreach (FDLWireDefinition tConnection in tFlowDefinition.Wires.Collection)
						{
							if ((tConnection.Target.Step == "Out")
								&& (tConnection.Target.Pin == tInterfaceDefinition.Name))
							{
								tConnectionFound = tConnection;
								break;
							}
						}
					}

					if (tConnectionFound == null)
					{
						FDLException tEx = new FDLException("Unused Interface found!",
							tInterfaceDefinition.LineNumber + 1, FileContentCache.Value[tInterfaceDefinition.LineNumber]);
						AppDefinitionCache.Value.ParseExceptions.Add(tEx);
					}
				}

				foreach (FDLWireDefinition tConnection in tFlowDefinition.Wires.Collection)
				{
					if (tConnection.Source.Step == "In")
					{
						if (tFlowDefinition.Interfaces.Collection.ContainsKey(tConnection.Source.Pin))
						{
							FDLInterfaceDefinition tInterface = tFlowDefinition.Interfaces.Collection[tConnection.Source.Pin];
							if (tInterface.Direction == Directions.Out)
							{
								FDLException tEx = new FDLException("Wire uses interface with wrong direction!",
									tConnection.LineNumber + 1, FileContentCache.Value[tConnection.LineNumber]);
								AppDefinitionCache.Value.ParseExceptions.Add(tEx);
							}
						}
						else
						{
							FDLException tEx = new FDLException("Wire uses unknown interface!",
								tConnection.LineNumber + 1, FileContentCache.Value[tConnection.LineNumber]);
							AppDefinitionCache.Value.ParseExceptions.Add(tEx);
						}
					}
					else if (tConnection.Target.Step == "Out")
					{
						if (tFlowDefinition.Interfaces.Collection.ContainsKey(tConnection.Target.Pin))
						{
							FDLInterfaceDefinition tInterface = tFlowDefinition.Interfaces.Collection[tConnection.Target.Pin];
							if (tInterface.Direction == Directions.In)
							{
								FDLException tEx = new FDLException("Wire uses interface with wrong direction!",
									tConnection.LineNumber + 1, FileContentCache.Value[tConnection.LineNumber]);
								AppDefinitionCache.Value.ParseExceptions.Add(tEx);
							}
						}
						else
						{
							FDLException tEx = new FDLException("Wire uses unknown interface!",
								tConnection.LineNumber + 1, FileContentCache.Value[tConnection.LineNumber]);
							AppDefinitionCache.Value.ParseExceptions.Add(tEx);
						}
					}
				}
			}

			Out_Output();
		}

		public event Action Out_Output;
	}
}
