﻿using System;
using AB3.AppDesigner.DataTypes;

namespace AB3.AppDesigner.Validators
{
	public class ValidateMainFlow
	{
		public void In_Input()
		{
			if (!AppDefinitionCache.Value.FlowDefinitions.ContainsKey("MainFlow"))
			{
				AB3.DataTypes.FDLException tEx = new AB3.DataTypes.FDLException("MainFlow is missing!", 1, string.Empty);
				AppDefinitionCache.Value.ParseExceptions.Add(tEx);
			}
			else
			{
				AB3.DataTypes.FDLFlowDefinition tMainFlow = AppDefinitionCache.Value.FlowDefinitions["MainFlow"];

				#region MainFlow may not have any interfaces
				if (tMainFlow.Interfaces.Collection.Count != 0)
				{
					AB3.DataTypes.FDLException tEx = new AB3.DataTypes.FDLException("MainFlow may not have any interfaces!",
						tMainFlow.Interfaces.Range.StartLine + 1,
						FileContentCache.Value[tMainFlow.Interfaces.Range.StartLine]);
					AppDefinitionCache.Value.ParseExceptions.Add(tEx);
				}
				#endregion
			}

			Out_Output();
		}

		public event Action Out_Output;
	}
}
